'Future.Library v3.50
'by Jorden Chamid and Michael Rye Sorensen

'*** SVGA Mouse ***
DECLARE SUB Future.updatemouse ALIAS "SVGAupdatemouse" ()
DECLARE SUB SetMouseRange (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB SetLocation (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMouseMaskColor ALIAS "SVGAmousemask" (BYVAL C&)
DECLARE SUB Future.MouseShape ALIAS "SVGAmouseShape" (BYVAL Offset%, BYVAL Segment%)
DECLARE SUB Future.ResetMouseShape ALIAS "MouseCursorGenerator" ()
DECLARE SUB future.mouseoff ALIAS "SVGAmouseoff" ()
DECLARE SUB future.mouseon ALIAS "SVGAmouseon" ()
DECLARE FUNCTION Future.MouseB% ALIAS "SVGAmouseB" ()
DECLARE FUNCTION Future.MouseY% ALIAS "SVGAmouseY" ()
DECLARE FUNCTION Future.MouseX% ALIAS "SVGAmouseX" ()
DECLARE SUB SetMouseSensitivity (BYVAL H%, BYVAL V%)
'*** Graphics ***
DECLARE SUB Set320x200 (B%)
DECLARE SUB Set320x240 (B%)
DECLARE SUB Set320x400 (B%)
DECLARE SUB Set320x480 (B%)
DECLARE SUB Set400x300 (B%)
DECLARE SUB Set512x384 (B%)
DECLARE SUB Set640x350 (B%)
DECLARE SUB Set640x400 (B%)
DECLARE SUB Set640x480 (B%)
DECLARE SUB Set720x480 (B%)
DECLARE SUB Set720x576 (B%)
DECLARE SUB Set800x600 (B%)
DECLARE SUB Set1024x768 (B%)
DECLARE SUB Set1152x864 (B%)
DECLARE SUB Set1280x960 (B%)
DECLARE SUB Set1280x1024 (B%)
DECLARE SUB Set1600x1200 (B%)
DECLARE SUB Set1920x1080 (B%)
DECLARE SUB Set1920x1200 (B%)
DECLARE SUB Set1920x1440 (B%)
DECLARE SUB Set2048x1536 (B%)
DECLARE SUB SetScreenMode (XRes%, YRes%, Bits%)
DECLARE SUB resetscreen
DECLARE FUNCTION Pages% ()
DECLARE FUNCTION IsVESA%
DECLARE FUNCTION VideoMemory&
DECLARE SUB ViewPage (BYVAL P%)
DECLARE SUB SetFrameBuffer ALIAS "SVGAframesize" (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMaskColor (BYVAL C&)
DECLARE SUB SetPage (BYVAL P%)
DECLARE SUB SetViewPort ALIAS "SVGAviewport" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE FUNCTION RGB2Color& (BYVAL R%, BYVAL G%, BYVAL B%)
DECLARE SUB Color2RGB (BYVAL C&, R%, G%, B%)
DECLARE FUNCTION Future.Version$ ()
DECLARE FUNCTION SizeOf& ALIAS "SVGAsizeof" (BYVAL X%, BYVAL Y%)
DECLARE FUNCTION Future.ModeList$ (I%)
DECLARE FUNCTION Future.POINT ALIAS "SVGApoint" (BYVAL X%, BYVAL Y%)
DECLARE SUB Future.ScrollUD ALIAS "SVGAscrollud" (BYVAL pixels%)
DECLARE SUB Future.ScrollLR ALIAS "SVGAscrolllr" (BYVAL pixels%)
DECLARE SUB Future.PSET ALIAS "SVGApset" (BYVAL X%, BYVAL Y%, BYVAL C&)
DECLARE SUB Future.CLS ALIAS "SVGAcls" (BYVAL C&)
DECLARE SUB future.fillbox ALIAS "SVGAfillbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.box ALIAS "SVGAbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.LINE ALIAS "SVGAline" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&, BYVAL Bitscan%)
DECLARE SUB Future.CIRCLE ALIAS "SVGAcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.FILLCIRCLE ALIAS "SVGAfillcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.HLINE ALIAS "SVGAhline" (BYVAL Y%, BYVAL X1%, BYVAL x2%, BYVAL C&)
DECLARE SUB Future.TRIFILL ALIAS "SVGAtrifill" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C&)
DECLARE SUB Future.TRIGOUR ALIAS "SVGAtrigour" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C1&, BYVAL C2&, BYVAL C3&)
DECLARE SUB Future.TRITEXT (X1%, Y1%, x2%, y2%, X3%, Y3%, U1%, V1%, U2%, V2%, U3%, V3%, Array() AS ANY)
DECLARE SUB Future.ROTATE (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.ROTATEB (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.SNAPSHOT (FileName$)
DECLARE SUB Future.GET (X%, Y%, X1%, Y1%, Array() AS ANY)
DECLARE SUB Future.PUT (X%, Y%, Array() AS ANY)
DECLARE SUB future.print (X%, Y%, t$, C&, B&)
DECLARE SUB Future.LoadGIF (FileName$, Xpos%, Ypos%)
TYPE TGIFInfo
       Filehandle AS INTEGER
       X AS INTEGER
       Y AS INTEGER
       BackgroundColor AS INTEGER
       Pal AS INTEGER
       NColor AS INTEGER
       GlobalCLUT AS STRING * 768
       loopit AS INTEGER
       StartFramePos AS LONG
       FramePos AS LONG
       EOFile AS INTEGER
END TYPE
DECLARE SUB Future.OpenAGif (FileName$, GifHandle AS TGIFInfo)
DECLARE SUB Future.CloseAGif (GifHandle AS TGIFInfo)
DECLARE SUB Future.putAGif (Xpos%, Ypos%, GifHandle AS TGIFInfo)
DECLARE SUB Future.LoadBMP (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadPCX (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadFONT (FileName$)
DECLARE SUB SetFont ALIAS "SVGAsetfont" (BYVAL Mode%)
DECLARE SUB LoadGIF (a$)
DECLARE SUB LoadPCX (a$)
DECLARE SUB LoadBMP (a$)

DECLARE SUB LoadScreen (FileName$)
DECLARE SUB SaveScreen (FileName$)
'*** Key handling ***
DECLARE SUB StickStatus (JoyX%, JoyY%, But1%, But2%, But3%)
DECLARE SUB LockKeys (Nr%, State%)
DECLARE SUB DisableBreak
DECLARE SUB ClearKeyBuffer
DECLARE FUNCTION GetKey% (BYVAL KeyCode%)
DECLARE SUB KBHon ()
DECLARE SUB KBHoff ()
'*** Misc. ***
DECLARE FUNCTION Timer2& ()
DECLARE SUB StartTIMER ()
DECLARE SUB StopTimer ()
DECLARE SUB SetTIMERspeed (BYVAL Frequency%)
DECLARE SUB ResetCounter ()
DECLARE FUNCTION ReadCounter& ()
DECLARE SUB StartSubTIMER (BYVAL TimerNr%)
DECLARE SUB StopSubTIMER (BYVAL TimerNr%)
DECLARE SUB SetSubTIMERspeed (BYVAL Frequency%, BYVAL TimerNr%)
DECLARE SUB ResetSubCounter (BYVAL TimerNr%)
DECLARE FUNCTION ReadSubCounter& (BYVAL TimerNr%)
'*** EMS ***
DECLARE SUB Future.EMSPut (X%, Y%, handle%)
DECLARE SUB Future.EMSGet (X%, Y%, X1%, Y1%, handle%)
DECLARE SUB Future.EMSPutx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMSGetx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMStoFile (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE SUB Future.FiletoEMS (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE FUNCTION GetEMMVersion! ()
DECLARE FUNCTION AllExpMem% (Bytes&)
DECLARE SUB DeallExpMem (handle%)
DECLARE SUB FreeAllExpMem ()
DECLARE FUNCTION PageFrameAddr% ()
DECLARE FUNCTION TotalPages% ()
DECLARE FUNCTION UnallocatedPages% ()
DECLARE FUNCTION IsEMMInstalled% ()
DECLARE SUB SetEMSpage (BYVAL EMSPageNumber%)
DECLARE SUB CopyEMSpage (BYVAL tEMSPageNumber%, BYVAL sEMSPageNumber%)
'*** XMS ***
DECLARE SUB Future.XMSget (X%, Y%, X1%, Y1%, XMShandle%)
DECLARE SUB Future.XMSput (X%, Y%, XMShandle%)
DECLARE FUNCTION IsXMSInstalled% ()
DECLARE FUNCTION AllocateXMS% (BYVAL Bytes&)
DECLARE SUB DeallocateXMS (BYVAL handle%)
DECLARE FUNCTION FreeXMSmemory& ()
DECLARE SUB MoveXMS (BYVAL SourceHandle%, BYVAL SourceOffset&, BYVAL DestHandle%, BYVAL DestOffset&, BYVAL Bytes&)
DECLARE SUB MoveToXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB MoveFromXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB Future.DefineXMSArray (X%, Y%, XMShandle%)
DECLARE SUB Future.XMSArrayGet (X%, Y%, XMShandle%, Index%)
DECLARE SUB Future.XMSArrayPut (X%, Y%, XMShandle%, Index%)

DEFINT A-Z

SUB memobox (X, Y, x2, y2, colour&)
future.mouseoff

'IF SU = 1 THEN savescr x, y, x2, y2: mhide ELSE IF mouse.ret > 0 THEN assign mouse.ret, x, x2, y, y2 - 3, 5


future.box X, Y, x2, y2 - 3, RGB2Color(150, 150, 150)

future.LINE X + 1, Y + 1, X + 1, y2 - 3, RGB2Color(90, 90, 90), -1

future.LINE X + 1, Y + 1, x2 - 1, Y + 1, RGB2Color(190, 190, 190), -1


future.LINE X + 1, Y + 1, x2, Y + 1, RGB2Color(90, 90, 90), -1

future.fillbox X + 2, Y + 2, x2 - 1, y2 - 3, colour&

future.LINE X + 2, y2 - 4, x2 - 2, y2 - 4, RGB2Color(200, 200, 200), -1

future.LINE X + 1, y2 - 3, x2 - 1, y2 - 3, RGB2Color(255, 255, 255), -1

'future.LINE x2 - 2, Y + 3, x2 - 2, y2 - 4, RGB2Color(200, 200, 200), -1
future.LINE x2 - 1, Y + 1, x2 - 1, y2 - 3, RGB2Color(255, 255, 255), -1
future.LINE x2, Y, x2, y2 - 3, RGB2Color(255, 255, 255), -1
future.LINE x2 - 1, Y + 2, x2 - 1, y2 - 4, RGB2Color(200, 200, 200), -1
'IF withsb = 1 THEN scrollbar x2 - 16, y + 2, y2 - 6, barlength

future.mouseon
END SUB

