DECLARE FUNCTION CheckBox.MouseOver% (ControlID%, X%, Y%)
DECLARE FUNCTION CheckBox.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION CheckBox.MouseUp% (ControlID%, Button%)
DECLARE SUB chkCursor (ControlID%, OnOff%)
DECLARE FUNCTION CheckBox.Value% (ControlID%)
DECLARE SUB DrawValue (ControlID%)
DECLARE FUNCTION CheckBox.Caption$ (ControlID%)
DECLARE FUNCTION CheckBox.TabStop% (ControlID%)
DECLARE FUNCTION CheckBox.Top% (ControlID%)
DECLARE FUNCTION CheckBox.Left% (ControlID%)
DECLARE FUNCTION CheckBox.LostFocus% (ControlID%)
DECLARE SUB CheckBox.ReDraw (ControlID%)
DECLARE SUB DestroyControl (ControlID%)
DECLARE FUNCTION CheckBox.Click% (ControlID%)
DECLARE FUNCTION CheckBox.KeyPress% (ControlID%, KeyChar$)
DECLARE SUB CheckBox.Destroy (ControlID%)
DECLARE FUNCTION CheckBox.GotFocus% (ControlID%)
DECLARE SUB Check (ControlID%)
DECLARE SUB UnCheck (ControlID%)
DECLARE SUB memobox (X%, Y%, x2%, y2%, colour&)
DECLARE FUNCTION CheckBox.Create% (Caption$, Left%, Top%, ForeColor&, BackColor&, CheckColor&, CheckBackColor&)
'Future.Library v3.50
'by Jorden Chamid and Michael Rye Sorensen

'*** SVGA Mouse ***
DECLARE SUB Future.UpdateMouse ALIAS "SVGAupdatemouse" ()
DECLARE SUB SetMouseRange (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB SetLocation (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMouseMaskColor ALIAS "SVGAmousemask" (BYVAL C&)
DECLARE SUB Future.MouseShape ALIAS "SVGAmouseShape" (BYVAL Offset%, BYVAL Segment%)
DECLARE SUB Future.ResetMouseShape ALIAS "MouseCursorGenerator" ()
DECLARE SUB Future.MouseOff ALIAS "SVGAmouseoff" ()
DECLARE SUB Future.MouseOn ALIAS "SVGAmouseon" ()
DECLARE FUNCTION Future.MouseB% ALIAS "SVGAmouseB" ()
DECLARE FUNCTION Future.MouseY% ALIAS "SVGAmouseY" ()
DECLARE FUNCTION Future.MouseX% ALIAS "SVGAmouseX" ()
DECLARE SUB SetMouseSensitivity (BYVAL H%, BYVAL V%)
'*** Graphics ***
DECLARE SUB Set320x200 (B%)
DECLARE SUB Set320x240 (B%)
DECLARE SUB Set320x400 (B%)
DECLARE SUB Set320x480 (B%)
DECLARE SUB Set400x300 (B%)
DECLARE SUB Set512x384 (B%)
DECLARE SUB Set640x350 (B%)
DECLARE SUB Set640x400 (B%)
DECLARE SUB Set640x480 (B%)
DECLARE SUB Set720x480 (B%)
DECLARE SUB Set720x576 (B%)
DECLARE SUB Set800x600 (B%)
DECLARE SUB Set1024x768 (B%)
DECLARE SUB Set1152x864 (B%)
DECLARE SUB Set1280x960 (B%)
DECLARE SUB Set1280x1024 (B%)
DECLARE SUB Set1600x1200 (B%)
DECLARE SUB Set1920x1080 (B%)
DECLARE SUB Set1920x1200 (B%)
DECLARE SUB Set1920x1440 (B%)
DECLARE SUB Set2048x1536 (B%)
DECLARE SUB SetScreenMode (XRes%, YRes%, Bits%)
DECLARE SUB ReSetScreen
DECLARE FUNCTION Pages% ()
DECLARE FUNCTION IsVESA%
DECLARE FUNCTION VideoMemory&
DECLARE SUB ViewPage (BYVAL P%)
DECLARE SUB SetFrameBuffer ALIAS "SVGAframesize" (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMaskColor (BYVAL C&)
DECLARE SUB SetPage (BYVAL P%)
DECLARE SUB SetViewPort ALIAS "SVGAviewport" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE FUNCTION RGB2Color& (BYVAL R%, BYVAL G%, BYVAL B%)
DECLARE SUB Color2RGB (BYVAL C&, R%, G%, B%)
DECLARE FUNCTION Future.Version$ ()
DECLARE FUNCTION SizeOf& ALIAS "SVGAsizeof" (BYVAL X%, BYVAL Y%)
DECLARE FUNCTION Future.ModeList$ (I%)
DECLARE FUNCTION Future.POINT ALIAS "SVGApoint" (BYVAL X%, BYVAL Y%)
DECLARE SUB Future.ScrollUD ALIAS "SVGAscrollud" (BYVAL pixels%)
DECLARE SUB Future.ScrollLR ALIAS "SVGAscrolllr" (BYVAL pixels%)
DECLARE SUB Future.PSET ALIAS "SVGApset" (BYVAL X%, BYVAL Y%, BYVAL C&)
DECLARE SUB Future.CLS ALIAS "SVGAcls" (BYVAL C&)
DECLARE SUB Future.FILLBOX ALIAS "SVGAfillbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB Future.BOX ALIAS "SVGAbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB Future.LINE ALIAS "SVGAline" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&, BYVAL Bitscan%)
DECLARE SUB Future.CIRCLE ALIAS "SVGAcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.FILLCIRCLE ALIAS "SVGAfillcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.HLINE ALIAS "SVGAhline" (BYVAL Y%, BYVAL X1%, BYVAL x2%, BYVAL C&)
DECLARE SUB Future.TRIFILL ALIAS "SVGAtrifill" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C&)
DECLARE SUB Future.TRIGOUR ALIAS "SVGAtrigour" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C1&, BYVAL C2&, BYVAL C3&)
DECLARE SUB Future.TRITEXT (X1%, Y1%, x2%, y2%, X3%, Y3%, U1%, V1%, U2%, V2%, U3%, V3%, Array() AS ANY)
DECLARE SUB Future.ROTATE (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.ROTATEB (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.SNAPSHOT (FileName$)
DECLARE SUB Future.GET (X%, Y%, X1%, Y1%, Array() AS ANY)
DECLARE SUB Future.PUT (X%, Y%, Array() AS ANY)
DECLARE SUB Future.PRINT (X%, Y%, T$, C&, B&)
DECLARE SUB Future.LoadGIF (FileName$, Xpos%, Ypos%)
TYPE TGIFInfo
       Filehandle AS INTEGER
       X AS INTEGER
       Y AS INTEGER
       BackgroundColor AS INTEGER
       Pal AS INTEGER
       NColor AS INTEGER
       GlobalCLUT AS STRING * 768
       loopit AS INTEGER
       StartFramePos AS LONG
       FramePos AS LONG
       EOFile AS INTEGER
END TYPE
DECLARE SUB Future.OpenAGif (FileName$, GifHandle AS TGIFInfo)
DECLARE SUB Future.CloseAGif (GifHandle AS TGIFInfo)
DECLARE SUB Future.putAGif (Xpos%, Ypos%, GifHandle AS TGIFInfo)
DECLARE SUB Future.LoadBMP (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadPCX (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadFONT (FileName$)
DECLARE SUB SetFont ALIAS "SVGAsetfont" (BYVAL Mode%)
DECLARE SUB LoadGIF (A$)
DECLARE SUB LoadPCX (A$)
DECLARE SUB LoadBMP (A$)

DECLARE SUB LoadScreen (FileName$)
DECLARE SUB SaveScreen (FileName$)
'*** Key handling ***
DECLARE SUB StickStatus (JoyX%, JoyY%, But1%, But2%, But3%)
DECLARE SUB LockKeys (Nr%, State%)
DECLARE SUB DisableBreak
DECLARE SUB ClearKeyBuffer
DECLARE FUNCTION GetKey% (BYVAL KeyCode%)
DECLARE SUB KBHon ()
DECLARE SUB KBHoff ()
'*** Misc. ***
DECLARE FUNCTION Timer2& ()
DECLARE SUB StartTIMER ()
DECLARE SUB StopTIMER ()
DECLARE SUB SetTIMERspeed (BYVAL Frequency%)
DECLARE SUB ResetCounter ()
DECLARE FUNCTION ReadCounter& ()
DECLARE SUB StartSubTIMER (BYVAL TimerNr%)
DECLARE SUB StopSubTIMER (BYVAL TimerNr%)
DECLARE SUB SetSubTIMERspeed (BYVAL Frequency%, BYVAL TimerNr%)
DECLARE SUB ResetSubCounter (BYVAL TimerNr%)
DECLARE FUNCTION ReadSubCounter& (BYVAL TimerNr%)
'*** EMS ***
DECLARE SUB Future.EMSPut (X%, Y%, handle%)
DECLARE SUB Future.EMSGet (X%, Y%, X1%, Y1%, handle%)
DECLARE SUB Future.EMSPutx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMSGetx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMStoFile (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE SUB Future.FiletoEMS (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE FUNCTION GetEMMVersion! ()
DECLARE FUNCTION AllExpMem% (Bytes&)
DECLARE SUB DeallExpMem (handle%)
DECLARE SUB FreeAllExpMem ()
DECLARE FUNCTION PageFrameAddr% ()
DECLARE FUNCTION TotalPages% ()
DECLARE FUNCTION UnallocatedPages% ()
DECLARE FUNCTION IsEMMInstalled% ()
DECLARE SUB SetEMSpage (BYVAL EMSPageNumber%)
DECLARE SUB CopyEMSpage (BYVAL tEMSPageNumber%, BYVAL sEMSPageNumber%)
'*** XMS ***
DECLARE SUB Future.XMSget (X%, Y%, X1%, Y1%, XMShandle%)
DECLARE SUB Future.XMSput (X%, Y%, XMShandle%)
DECLARE FUNCTION IsXMSInstalled% ()
DECLARE FUNCTION AllocateXMS% (BYVAL Bytes&)
DECLARE SUB DeallocateXMS (BYVAL handle%)
DECLARE FUNCTION FreeXMSmemory& ()
DECLARE SUB MoveXMS (BYVAL SourceHandle%, BYVAL SourceOffset&, BYVAL DestHandle%, BYVAL DestOffset&, BYVAL Bytes&)
DECLARE SUB MoveToXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB MoveFromXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB Future.DefineXMSArray (X%, Y%, XMShandle%)
DECLARE SUB Future.XMSArrayGet (X%, Y%, XMShandle%, Index%)
DECLARE SUB Future.XMSArrayPut (X%, Y%, XMShandle%, Index%)

DEFINT A-Z

DECLARE FUNCTION MouseX% ()
DECLARE FUNCTION MouseY% ()
DECLARE FUNCTION MouseB% ()


DECLARE FUNCTION XMS2D.GetItem$ (handle AS ANY, xIndex%, yIndex&)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE FUNCTION Button.GotFocus% (ControlID%)
DECLARE FUNCTION Button.Create% (Caption$, Left%, Top%, Width.%, Height%, ForeColor&, BackColor&)
DECLARE FUNCTION Button.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION Button.LostFocus% (ControlID%)
DECLARE FUNCTION Button.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION Button.MouseOver% (ControlID%, X%, Y%)
DECLARE FUNCTION Button.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION Button.Click% (ControlID%)

DECLARE SUB SetLongProp (ControlID%, Index%, Value&)
DECLARE SUB SetIntProp (ControlID%, Index%, Value%)
DECLARE SUB SetIntEvent (ControlID%, Index%, Value%)
DECLARE FUNCTION UnivSwitch% (ControlID%, Index%)

DECLARE FUNCTION ActiveControl% ()
DECLARE SUB SetActiveControl (ControlID%)
DECLARE FUNCTION IntEvent% (ControlID%, Index%)
DECLARE FUNCTION IntProp% (ControlID%, Index%)
DECLARE FUNCTION LongProp& (ControlID%, Index%)
DECLARE FUNCTION StrProp$ (ControlID%, Index%)
DECLARE SUB SetStrProp (ControlID%, Index%, Value$)

DECLARE FUNCTION UnivKey$ ()

SUB Check (ControlID%)
  X = IntProp(ControlID, 1) + 2
  Y = IntProp(ControlID, 2) + 2
  
  Future.MouseOff


  SELECT CASE IntProp(ControlID, 4)
        CASE IS = 0
                Future.LINE X + 1, Y + 5, X + 5, Y + 8, LongProp(ControlID, 3), -1
                Future.LINE X + 2, Y + 5, X + 5, Y + 7, LongProp(ControlID, 3), -1
                Future.LINE X + 3, Y + 5, X + 5, Y + 6, LongProp(ControlID, 3), -1
                Future.LINE X + 9, Y + 1, X + 5, Y + 9, LongProp(ControlID, 3), -1
                Future.LINE X + 8, Y + 1, X + 5, Y + 9, LongProp(ControlID, 3), -1
                Future.LINE X + 8, Y + 1, X + 4, Y + 9, LongProp(ControlID, 3), -1
  END SELECT

  Future.MouseOn
        
END SUB

FUNCTION CheckBox.Caption$ (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.Caption$ = StrProp(ControlID, 2)

END FUNCTION

FUNCTION CheckBox.Click% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.Click% = IntEvent(ControlID, 1)  ' click index is 1

END FUNCTION

FUNCTION CheckBox.Create% (Caption$, Left%, Top%, ForeColor&, BackColor&, CheckColor&, CheckBackColor&)

  X = Left%
  Y = Top%
  x2 = X + 15
  y2 = Y + 18
  ClickX = X - 2
  ClickX2 = x2 + (LEN(Caption$) * 8) + 6
  ClickY = Y - 2
  ClickY2 = y2

FOR ctr = 1 TO 150
  IF IntProp(ctr, 28) = 0 THEN
    freeID = ctr
    EXIT FOR
  END IF
NEXT


SetStrProp freeID, 1, "checkbox"           'Control Type
SetStrProp freeID, 2, Caption$             'Caption
SetStrProp freeID, 3, ""                   'ToolTipText
SetStrProp freeID, 4, ""                   'Tag

SetIntProp freeID, 1, Left%                             'Left
SetIntProp freeID, 2, Top%             'Top
SetIntProp freeID, 3, 0                'Value
SetIntProp freeID, 4, 0                'CheckType
SetIntProp freeID, 5, 0                'free
SetIntProp freeID, 6, 1                'Enabled
SetIntProp freeID, 7, 1                'TabStop
SetIntProp freeID, 8, ClickX           'ClickX
SetIntProp freeID, 9, ClickY           'ClickY
SetIntProp freeID, 10, ClickX2         'ClickX2
SetIntProp freeID, 11, ClickY2         'ClickY2
SetIntProp freeID, 12, 0               'free
SetIntProp freeID, 13, 0               'free

SetIntProp freeID, 28, 31234           'control type number
SetIntProp freeID, 29, 0               'free
SetIntProp freeID, 30, 0               'Force process switch


SetLongProp freeID, 1, ForeColor&       'ForeColor
SetLongProp freeID, 2, BackColor&       'BackColor
SetLongProp freeID, 3, CheckColor&      'CheckColor
SetLongProp freeID, 4, CheckBackColor&  'CheckBackColor

CheckBox.ReDraw freeID

CheckBox.Create = freeID


END FUNCTION

SUB CheckBox.Destroy (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT SUB

  DestroyControl ControlID

END SUB

SUB CheckBox.DestroyAll

  FOR ctr = 1 TO 150
    CheckBox.Destroy ctr
  NEXT

END SUB

SUB CheckBox.DoEvent (ControlID%)

  IF IntProp(ControlID%, 28) <> 31234 THEN EXIT SUB

  Future.UpdateMouse

  DIM MX%, MY%, MB%

        IF IntEvent(ControlID, 3) = 1 THEN  'if control has lostfocus
                GOSUB remcursor
        END IF


'turn off all events

  SetIntEvent ControlID, 1, 0   'turn off click
  SetIntEvent ControlID, 2, 0   'turn off gotfocus
  SetIntEvent ControlID, 3, 0  'turn off lostfocus
  SetIntEvent ControlID, 4, 0   'turn off mouseover
  SetIntEvent ControlID, 5, 0   'turn off mouseover x
  SetIntEvent ControlID, 6, 0   'turn off mouseover y
  SetIntEvent ControlID, 7, 0  'turn off mousedown
  SetIntEvent ControlID, 8, 0   'turn off mousedown button
  SetIntEvent ControlID, 9, 0   'turn off mouseup
  SetIntEvent ControlID, 10, 0  'turn off mouseup button
  SetIntEvent ControlID, 11, 0  'turn off keypress
  SetIntEvent ControlID, 12, 0  'turn off keypress char
  SetIntEvent ControlID, 13, 0  'turn off keypress char 2
  SetIntEvent ControlID, 14, 0  'turn off change event

  IF ActiveControl = 0 AND IntProp(ControlID, 7) = 1 THEN
    SetActiveControl ControlID
    SetIntEvent ControlID, 2, 1  ' gotfocus index is 2
    GOSUB PutCursor
    EXIT SUB
  END IF




KeyChar$ = UnivKey$
 
IF ActiveControl = ControlID THEN
   IF KeyChar$ = CHR$(32) THEN
      SetIntEvent ControlID, 1, 1   'click event index is 1
      GOSUB SetKeyEvent
      GOSUB SetVal
       
   ELSEIF KeyChar$ = CHR$(9) THEN
      GOSUB SetKeyEvent

      GOSUB remcursor
      SetIntEvent ControlID, 3, 1  ' lostfocus index is 3
      SetActiveControl 0
      EXIT SUB
   ELSEIF KeyChar$ <> "" THEN
      GOSUB SetKeyEvent
     
   END IF
END IF


  GOSUB GetClickXY

  MX = MouseX
  MY = MouseY
  MB = MouseB

  MouseDown% = IntProp(ControlID, 30)

IF MX > ClickX AND MX < ClickX2 AND MY > ClickY AND MY < ClickY2 THEN


        SetIntEvent ControlID, 4, 1  'mouseover index is 4
        SetIntEvent ControlID, 5, MX - ClickX 'mouseover X index is 5
        SetIntEvent ControlID, 6, MY - ClickY 'mouseover Y index is 6


    IF MB = 0 THEN
        IF MouseDown% = 1 THEN
                SetIntEvent ControlID, 1, 1   'click event index is 1
                
                GOSUB SetVal

                IF ActiveControl <> ControlID THEN
                        SetIntEvent ActiveControl, 3, 1     'Set lostfocus to active control
                        SetIntEvent ControlID, 2, 1  ' gotfocus index is 2
                        GOSUB PutCursor
                        SetActiveControl ControlID
                END IF

        END IF
        SetIntProp ControlID, 30, 0

        IF MouseDown% THEN
                SetIntEvent ControlID, 9, 1    ' mouseup index is 9
                SetIntEvent ControlID, 10, MouseDown% ' mouseup button index is 10
        END IF

    ELSE
        SetIntProp ControlID, 30, MB
        SetIntEvent ControlID, 7, 1       ' mousedown index is 7
        SetIntEvent ControlID, 8, MB      ' mousedown button index is 8

    END IF
ELSE

        SetIntProp ControlID, 30, 0

END IF
  

  EXIT SUB

remcursor:
   chkCursor ControlID, 0
   RETURN
   
PutCursor:
   chkCursor ControlID, 1
   RETURN

GetClickXY:
  
  ClickX = IntProp(ControlID, 8)
  ClickY = IntProp(ControlID, 9)
  ClickX2 = IntProp(ControlID, 10)
  ClickY2 = IntProp(ControlID, 11)

  RETURN

SetVal:

        Value% = IntProp(ControlID, 3)
        IF Value% = 0 THEN
                SetIntProp ControlID, 3, 1
                Check ControlID
        ELSE
                SetIntProp ControlID, 3, 0
                UnCheck ControlID
        END IF

        RETURN

SetKeyEvent:
      SetIntEvent ControlID, 11, 1              ' keypress index is 11

      IF LEN(KeyChar$) = 1 THEN
        SetIntEvent ControlID, 12, ASC(KeyChar$)  ' keypress char index is 12
      ELSE
        SetIntEvent ControlID, 12, ASC(LEFT$(KeyChar$, 1))
        SetIntEvent ControlID, 13, ASC(MID$(KeyChar$, 2, 1))
      END IF

      RETURN

END SUB

FUNCTION CheckBox.GotFocus% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.GotFocus% = IntEvent(ControlID%, 2)

END FUNCTION

FUNCTION CheckBox.KeyPress% (ControlID%, KeyChar$)

  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION

  IsKeyPress = IntEvent(ControlID, 11)' keypress index is 11

  IF IsKeyPress THEN
    CheckBox.KeyPress% = 1
    temp$ = CHR$(IntEvent(ControlID, 12))         'keypress key index is 12
    temp$ = temp$ + CHR$(IntEvent(ControlID, 13))
    KeyChar$ = temp$
  ELSE
    KeyChar$ = ""
  END IF


END FUNCTION

FUNCTION CheckBox.Left% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.Left% = IntProp(ControlID, 1)                            'Left
       
END FUNCTION

FUNCTION CheckBox.LostFocus% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.LostFocus% = IntEvent(ControlID%, 3)
       
END FUNCTION

FUNCTION CheckBox.MouseDown% (ControlID%, Button%)

  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION

  IsMouseDown = IntEvent(ControlID, 7)' mousedown index is 7

  IF IsMouseDown THEN
    CheckBox.MouseDown% = 1
    Button% = IntEvent(ControlID, 8)    'mousedown button index is 8
  ELSE
    Button% = 0
  END IF


END FUNCTION

FUNCTION CheckBox.MouseOver% (ControlID%, X%, Y%)

  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION

  IsMouseOver = IntEvent(ControlID, 4)' mouseover index is 4

  IF IsMouseOver THEN
     CheckBox.MouseOver = 1
     X% = IntEvent(ControlID, 5) 'mouseover X index is 5
     Y% = IntEvent(ControlID, 6) 'mouseover Y index is 6
  ELSE
     X% = 0
     Y% = 0
  END IF



END FUNCTION

FUNCTION CheckBox.MouseUp% (ControlID%, Button%)

  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION

  IsMouseUp = IntEvent(ControlID, 9)' mouseup index is 9

  IF IsMouseUp THEN
    CheckBox.MouseUp% = 1
    Button% = IntEvent(ControlID, 10) 'mouseup button index is 10
  ELSE
    Button% = 0
  END IF

END FUNCTION

SUB CheckBox.ReDraw (ControlID%)

  IF IntProp(ControlID, 28) <> 31234 THEN EXIT SUB


'SetStrProp freeID, 1, "checkbox"           'Control Type
Caption$ = StrProp(ControlID, 2)          'Caption
'SetStrProp freeID, 3,""                'ToolTipText
'SetStrProp freeID, 4, ""                   'Tag

Left% = IntProp(ControlID, 1)                           'Left
Top% = IntProp(ControlID, 2)           'Top
Value% = IntProp(ControlID, 3)         'Value
'SetIntProp freeID, 4, 0                'CheckType
'SetIntProp freeID, 5, 0                'free
'SetIntProp freeID, 6, 1                'Enabled
'SetIntProp freeID, 7, 1                'TabStop
'SetIntProp freeID, 8, ClickX           'ClickX
'SetIntProp freeID, 9, ClickY           'ClickY
'SetIntProp freeID, 10, ClickX2         'ClickX2
'SetIntProp freeID, 11, ClickY2         'ClickY2
'SetIntProp freeID, 12, 0               'free
'SetIntProp freeID, 13, 0               'free

'SetIntProp freeID, 28, 31234           'control type number
'SetIntProp freeID, 29, 0               'free
'SetIntProp freeID, 30, 0               'Force process switch

  X = Left%
  Y = Top%
  x2 = X + 15
  y2 = Y + 18

  ClickX = IntProp(ControlID, 8)
  ClickX2 = IntProp(ControlID, 10)
  ClickY = IntProp(ControlID, 9)
  ClickY2 = IntProp(ControlID, 11)

ForeColor& = LongProp(ControlID, 1)     'ForeColor
BackColor& = LongProp(ControlID, 2)      'BackColor
CheckColor& = LongProp(ControlID, 3)    'CheckColor
CheckBackColor& = LongProp(ControlID, 4)'CheckBackColor

                                   
        Future.MouseOff
        Future.FILLBOX ClickX, ClickY, ClickX2, ClickY2, BackColor&
        memobox X, Y, x2, y2, CheckBackColor&
        Future.MouseOff
        Future.PRINT x2 + 5, Y + 1, Caption$, ForeColor&, -1
        Future.MouseOn
        IF Value% THEN Check ControlID

END SUB

SUB CheckBox.ReDrawAll

        FOR ctr = 1 TO 150
           CheckBox.ReDraw ctr
        NEXT

END SUB

SUB CheckBox.SetCaption (ControlID%, Caption$)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT SUB

  SetStrProp ControlID, 2, Caption$
  CheckBox.ReDraw ControlID
  ClickX2 = IntProp(ControlID, 1) + 15 + (LEN(Caption$) * 8) + 6
  SetIntProp ControlID, 10, ClickX2
  
  IF ActiveControl = ControlID THEN chkCursor ControlID, 1
 
END SUB

SUB CheckBox.SetTabStop (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT SUB
  SetIntProp ControlID%, 7, Value%  'TabStop index is 7

END SUB

SUB CheckBox.SetValue (ControlID%, Value%)
        IF IntProp(ControlID, 28) <> 31234 THEN EXIT SUB

        SetIntProp ControlID, 3, Value%
        DrawValue ControlID

END SUB

FUNCTION CheckBox.TabStop% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.TabStop% = IntProp(ControlID%, 7)  'TabStop index is 7

END FUNCTION

FUNCTION CheckBox.Top% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.Top% = IntProp(ControlID, 2)   'top
       
END FUNCTION

FUNCTION CheckBox.Value% (ControlID%)
  IF IntProp(ControlID, 28) <> 31234 THEN EXIT FUNCTION
  CheckBox.Value% = IntProp(ControlID, 3)
END FUNCTION

SUB chkCursor (ControlID%, OnOff%)

  ClickX = IntProp(ControlID, 8)
  ClickY = IntProp(ControlID, 9)
  ClickX2 = IntProp(ControlID, 10)
  ClickY2 = IntProp(ControlID, 11)

   IF OnOff% = 0 THEN

        Future.MouseOff
        Future.BOX ClickX, ClickY, ClickX2, ClickY2, LongProp(ControlID, 2)
        Future.MouseOn
  ELSE
        Future.MouseOff
        Future.BOX ClickX, ClickY, ClickX2, ClickY2, RGB2Color(150, 150, 150)
        Future.MouseOn
  END IF
END SUB

SUB DrawValue (ControlID%)

        Value% = IntProp(ControlID, 3)
        IF Value% = 1 THEN
                Check ControlID
        ELSE
                UnCheck ControlID
        END IF

END SUB

SUB UnCheck (ControlID%)

  X = IntProp(ControlID, 1) + 2
  Y = IntProp(ControlID, 2) + 2

  Future.MouseOff

  Future.FILLBOX X, Y, X + 10, Y + 10, LongProp(ControlID, 4)

  Future.MouseOn

END SUB

