DECLARE FUNCTION VScroll.TabStop% (ControlID%)
DECLARE FUNCTION VScroll.LargeChange% (ControlID%)
DECLARE FUNCTION VScroll.SmallChange% (ControlID%)
DECLARE FUNCTION VScroll.Height% (ControlID%)
DECLARE FUNCTION VScroll.Left% (ControlID%)
DECLARE FUNCTION VScroll.Top% (ControlID%)
DECLARE FUNCTION VScroll.Width% (ControlID%)
DECLARE SUB DestroyControl (ControlID%)
DECLARE SUB VScroll.Destroy (ControlID%)
DECLARE SUB VScroll.ReDraw (ControlID%)
DECLARE SUB Button.ReDraw (ControlID%)
DECLARE FUNCTION VScroll.Change% (ControlID%)
'Future.Library v3.50
'by Jorden Chamid and Michael Rye Sorensen

'*** SVGA Mouse ***
DECLARE SUB Future.UpdateMouse ALIAS "SVGAupdatemouse" ()
DECLARE SUB SetMouseRange (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB SetLocation (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMouseMaskColor ALIAS "SVGAmousemask" (BYVAL C&)
DECLARE SUB Future.MouseShape ALIAS "SVGAmouseShape" (BYVAL Offset%, BYVAL Segment%)
DECLARE SUB Future.ResetMouseShape ALIAS "MouseCursorGenerator" ()
DECLARE SUB Future.MouseOff ALIAS "SVGAmouseoff" ()
DECLARE SUB Future.MouseOn ALIAS "SVGAmouseon" ()
DECLARE FUNCTION Future.MouseB% ALIAS "SVGAmouseB" ()
DECLARE FUNCTION Future.MouseY% ALIAS "SVGAmouseY" ()
DECLARE FUNCTION Future.MouseX% ALIAS "SVGAmouseX" ()
DECLARE SUB SetMouseSensitivity (BYVAL H%, BYVAL V%)
'*** Graphics ***
DECLARE SUB Set320x200 (B%)
DECLARE SUB Set320x240 (B%)
DECLARE SUB Set320x400 (B%)
DECLARE SUB Set320x480 (B%)
DECLARE SUB Set400x300 (B%)
DECLARE SUB Set512x384 (B%)
DECLARE SUB Set640x350 (B%)
DECLARE SUB Set640x400 (B%)
DECLARE SUB Set640x480 (B%)
DECLARE SUB Set720x480 (B%)
DECLARE SUB Set720x576 (B%)
DECLARE SUB Set800x600 (B%)
DECLARE SUB Set1024x768 (B%)
DECLARE SUB Set1152x864 (B%)
DECLARE SUB Set1280x960 (B%)
DECLARE SUB Set1280x1024 (B%)
DECLARE SUB Set1600x1200 (B%)
DECLARE SUB Set1920x1080 (B%)
DECLARE SUB Set1920x1200 (B%)
DECLARE SUB Set1920x1440 (B%)
DECLARE SUB Set2048x1536 (B%)
DECLARE SUB SetScreenMode (XRes%, YRes%, Bits%)
DECLARE SUB ReSetScreen
DECLARE FUNCTION Pages% ()
DECLARE FUNCTION IsVESA%
DECLARE FUNCTION VideoMemory&
DECLARE SUB ViewPage (BYVAL P%)
DECLARE SUB SetFrameBuffer ALIAS "SVGAframesize" (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMaskColor (BYVAL C&)
DECLARE SUB SetPage (BYVAL P%)
DECLARE SUB SetViewPort ALIAS "SVGAviewport" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE FUNCTION RGB2Color& (BYVAL R%, BYVAL G%, BYVAL B%)
DECLARE SUB Color2RGB (BYVAL C&, R%, G%, B%)
DECLARE FUNCTION Future.Version$ ()
DECLARE FUNCTION SizeOf& ALIAS "SVGAsizeof" (BYVAL X%, BYVAL Y%)
DECLARE FUNCTION Future.ModeList$ (I%)
DECLARE FUNCTION Future.POINT ALIAS "SVGApoint" (BYVAL X%, BYVAL Y%)
DECLARE SUB Future.ScrollUD ALIAS "SVGAscrollud" (BYVAL pixels%)
DECLARE SUB Future.ScrollLR ALIAS "SVGAscrolllr" (BYVAL pixels%)
DECLARE SUB Future.PSET ALIAS "SVGApset" (BYVAL X%, BYVAL Y%, BYVAL C&)
DECLARE SUB Future.CLS ALIAS "SVGAcls" (BYVAL C&)
DECLARE SUB Future.FILLBOX ALIAS "SVGAfillbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB Future.BOX ALIAS "SVGAbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB Future.LINE ALIAS "SVGAline" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&, BYVAL Bitscan%)
DECLARE SUB Future.CIRCLE ALIAS "SVGAcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.FILLCIRCLE ALIAS "SVGAfillcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.HLINE ALIAS "SVGAhline" (BYVAL Y%, BYVAL X1%, BYVAL x2%, BYVAL C&)
DECLARE SUB Future.TRIFILL ALIAS "SVGAtrifill" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C&)
DECLARE SUB Future.TRIGOUR ALIAS "SVGAtrigour" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C1&, BYVAL C2&, BYVAL C3&)
DECLARE SUB Future.TRITEXT (X1%, Y1%, x2%, y2%, X3%, Y3%, U1%, V1%, U2%, V2%, U3%, V3%, Array() AS ANY)
DECLARE SUB Future.ROTATE (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.ROTATEB (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.SNAPSHOT (FileName$)
DECLARE SUB Future.GET (X%, Y%, X1%, Y1%, Array() AS ANY)
DECLARE SUB Future.PUT (X%, Y%, Array() AS ANY)
DECLARE SUB Future.PRINT (X%, Y%, t$, C&, B&)
DECLARE SUB Future.LoadGIF (FileName$, Xpos%, Ypos%)
TYPE TGIFInfo
       Filehandle AS INTEGER
       X AS INTEGER
       Y AS INTEGER
       BackgroundColor AS INTEGER
       Pal AS INTEGER
       NColor AS INTEGER
       GlobalCLUT AS STRING * 768
       loopit AS INTEGER
       StartFramePos AS LONG
       FramePos AS LONG
       EOFile AS INTEGER
END TYPE
DECLARE SUB Future.OpenAGif (FileName$, GifHandle AS TGIFInfo)
DECLARE SUB Future.CloseAGif (GifHandle AS TGIFInfo)
DECLARE SUB Future.putAGif (Xpos%, Ypos%, GifHandle AS TGIFInfo)
DECLARE SUB Future.LoadBMP (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadPCX (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadFONT (FileName$)
DECLARE SUB SetFont ALIAS "SVGAsetfont" (BYVAL Mode%)
DECLARE SUB LoadGIF (a$)
DECLARE SUB LoadPCX (a$)
DECLARE SUB LoadBMP (a$)

DECLARE SUB LoadScreen (FileName$)
DECLARE SUB SaveScreen (FileName$)
'*** Key handling ***
DECLARE SUB StickStatus (JoyX%, JoyY%, But1%, But2%, But3%)
DECLARE SUB LockKeys (Nr%, State%)
DECLARE SUB DisableBreak
DECLARE SUB ClearKeyBuffer
DECLARE FUNCTION GetKey% (BYVAL KeyCode%)
DECLARE SUB KBHon ()
DECLARE SUB KBHoff ()
'*** Misc. ***
DECLARE FUNCTION Timer2& ()
DECLARE SUB StartTIMER ()
DECLARE SUB StopTIMER ()
DECLARE SUB SetTIMERspeed (BYVAL Frequency%)
DECLARE SUB ResetCounter ()
DECLARE FUNCTION ReadCounter& ()
DECLARE SUB StartSubTIMER (BYVAL TimerNr%)
DECLARE SUB StopSubTIMER (BYVAL TimerNr%)
DECLARE SUB SetSubTIMERspeed (BYVAL Frequency%, BYVAL TimerNr%)
DECLARE SUB ResetSubCounter (BYVAL TimerNr%)
DECLARE FUNCTION ReadSubCounter& (BYVAL TimerNr%)
'*** EMS ***
DECLARE SUB Future.EMSPut (X%, Y%, handle%)
DECLARE SUB Future.EMSGet (X%, Y%, X1%, Y1%, handle%)
DECLARE SUB Future.EMSPutx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMSGetx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMStoFile (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE SUB Future.FiletoEMS (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE FUNCTION GetEMMVersion! ()
DECLARE FUNCTION AllExpMem% (Bytes&)
DECLARE SUB DeallExpMem (handle%)
DECLARE SUB FreeAllExpMem ()
DECLARE FUNCTION PageFrameAddr% ()
DECLARE FUNCTION TotalPages% ()
DECLARE FUNCTION UnallocatedPages% ()
DECLARE FUNCTION IsEMMInstalled% ()
DECLARE SUB SetEMSpage (BYVAL EMSPageNumber%)
DECLARE SUB CopyEMSpage (BYVAL tEMSPageNumber%, BYVAL sEMSPageNumber%)
'*** XMS ***
DECLARE SUB Future.XMSget (X%, Y%, X1%, Y1%, XMShandle%)
DECLARE SUB Future.XMSput (X%, Y%, XMShandle%)
DECLARE FUNCTION IsXMSInstalled% ()
DECLARE FUNCTION AllocateXMS% (BYVAL Bytes&)
DECLARE SUB DeallocateXMS (BYVAL handle%)
DECLARE FUNCTION FreeXMSmemory& ()
DECLARE SUB MoveXMS (BYVAL SourceHandle%, BYVAL SourceOffset&, BYVAL DestHandle%, BYVAL DestOffset&, BYVAL Bytes&)
DECLARE SUB MoveToXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB MoveFromXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB Future.DefineXMSArray (X%, Y%, XMShandle%)
DECLARE SUB Future.XMSArrayGet (X%, Y%, XMShandle%, Index%)
DECLARE SUB Future.XMSArrayPut (X%, Y%, XMShandle%, Index%)

DEFINT A-Z



DECLARE FUNCTION MouseX% ()
DECLARE FUNCTION MouseY% ()
DECLARE FUNCTION MouseB% ()


DECLARE SUB Delay (Counter#)

DECLARE SUB VScroll.SetValue (ControlID%, Value&)
DECLARE FUNCTION VScroll.MaxValue& (ControlID%)
DECLARE FUNCTION VScroll.Value& (ControlID%)
DECLARE SUB endvqb ()


DECLARE SUB Button.DoEvent (ControlID%)
DECLARE FUNCTION VScroll.Create% (Left%, Top%, Height%, ForeColor&, BackColor&)

DECLARE FUNCTION XMS2D.GetItem$ (handle AS ANY, xIndex%, yIndex&)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE FUNCTION Button.GotFocus% (ControlID%)
DECLARE FUNCTION Button.Create% (Caption$, Left%, Top%, Width.%, Height%, ForeColor&, BackColor&)
DECLARE FUNCTION Button.KeyPress% (ControlID%, Keychar$)
DECLARE FUNCTION Button.LostFocus% (ControlID%)
DECLARE FUNCTION Button.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION Button.MouseOver% (ControlID%, X%, Y%)
DECLARE FUNCTION Button.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION Button.Click% (ControlID%)

DECLARE SUB SetLongProp (ControlID%, Index%, Value&)
DECLARE SUB SetIntProp (ControlID%, Index%, Value%)
DECLARE SUB SetIntEvent (ControlID%, Index%, Value%)
DECLARE FUNCTION UnivSwitch% (ControlID%, Index%)

DECLARE FUNCTION ActiveControl% ()
DECLARE SUB SetActiveControl (ControlID%)
DECLARE FUNCTION IntEvent% (ControlID%, Index%)
DECLARE FUNCTION IntProp% (ControlID%, Index%)
DECLARE FUNCTION LongProp& (ControlID%, Index%)
DECLARE FUNCTION StrProp$ (ControlID%, Index%)
DECLARE SUB SetStrProp (ControlID%, Index%, Value$)

DECLARE FUNCTION UnivKey$ ()

FUNCTION VScroll.Change% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  IF LongProp(ControlID%, 3) > 0 THEN VScroll.Change% = IntEvent(ControlID%, 1) 'Change event index is 1
END FUNCTION

FUNCTION VScroll.Create% (Left%, Top%, Height%, ForeColor&, BackColor&)

STATIC freeID%

FOR ctr = 1 TO 150
  IF IntProp(ctr, 28) = 0 THEN
    freeID = ctr
    EXIT FOR
  END IF
NEXT

x2 = Left% + 20
y2 = Top% + Height%

SetStrProp freeID, 1, "vscroll"           'control Type
'SetStrProp freeID, 2, Caption$           'Caption
SetStrProp freeID, 3, ""                 'ToolTipText
SetStrProp freeID, 4, ""                 'Tag

SetIntProp freeID, 1, Left%                             'Left
SetIntProp freeID, 2, Top%         'Top
SetIntProp freeID, 3, 1            'SmallChange
SetIntProp freeID, 4, Height%     'Height
SetIntProp freeID, 5, 1           'LargeChange
SetIntProp freeID, 6, 1                'Enabled
SetIntProp freeID, 7, 1                'TabStop

SetIntProp freeID, 28, 23456           'control type number
'SetIntProp freeID, 29, 0               'No Push switch
SetIntProp freeID, 30, 0               'Force process switch

SetLongProp freeID, 1, ForeColor&  'ForeColor
SetLongProp freeID, 2, BackColor&  'BackColor
maxValue& = Height% - 70
SetLongProp freeID, 3, maxValue&  'MaxValue

SetLongProp freeID, 4, 0           'Value


VScroll.Create% = freeID

Future.MouseOff
Future.FILLBOX Left%, Top%, x2%, y2%, RGB2Color(180, 180, 180)

'up button
temp = Button.Create("", Left%, Top%, 20, 20, ForeColor&, BackColor&)
Future.MouseOff
Future.PSET Left% + 10, Top% + 7, ForeColor&
Future.LINE Left% + 9, Top% + 8, x2 - 9, Top% + 8, ForeColor&, -1
Future.LINE Left% + 8, Top% + 9, x2 - 8, Top% + 9, ForeColor&, -1
Future.LINE Left% + 7, Top% + 10, x2 - 7, Top% + 10, ForeColor&, -1
Future.LINE Left% + 6, Top% + 11, x2 - 6, Top% + 11, ForeColor&, -1
SetIntProp temp, 7, 0   'set TabStop to 0


'down button
temp = Button.Create("", Left%, y2 - 20, 20, 20, ForeColor&, BackColor&)
Future.MouseOff
Future.PSET Left% + 10, y2 - 7, ForeColor&
Future.LINE Left% + 9, y2 - 8, x2 - 9, y2 - 8, ForeColor&, -1
Future.LINE Left% + 8, y2 - 9, x2 - 8, y2 - 9, ForeColor&, -1
Future.LINE Left% + 7, y2 - 10, x2 - 7, y2 - 10, ForeColor&, -1
Future.LINE Left% + 6, y2 - 11, x2 - 6, y2 - 11, ForeColor&, -1
SetIntProp temp, 7, 0   'set TabStop to 0

'scroll button
temp = Button.Create("", Left%, Top% + 20 + 1, 20, 30, ForeColor&, BackColor&)
SetIntProp temp, 29, 1               'No Push switch


END FUNCTION

SUB VScroll.Destroy (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB
  DestroyControl ControlID

END SUB

SUB VScroll.DestroyAll

  FOR ctr = 1 TO 150
    VScroll.Destroy ctr
  NEXT

END SUB

SUB VScroll.DoEvent (ControlID%)

  IF IntProp(ControlID%, 28) <> 23456 THEN EXIT SUB

  Future.UpdateMouse

  STATIC prevMX%, prevMY%, bX%, bY%, bX2%, bY2%, handle%, tempY%, MX%, MY%

  Button.DoEvent ControlID% + 1
  Button.DoEvent ControlID% + 2
  Button.DoEvent ControlID% + 3


  SetIntEvent ControlID%, 1, 0


  IF Button.KeyPress(ControlID% + 3, Keychar$) THEN
    IF Keychar$ = CHR$(0) + CHR$(80) THEN GOTO down1  'down arrow key was pressed at the scroll button
    IF Keychar$ = CHR$(0) + CHR$(72) THEN GOTO up1  'up arrow key was pressed at the scroll button
  END IF


  IF Button.Click(ControlID% + 1) THEN
up1:
     cValue& = VScroll.Value&(ControlID%)
     cValue& = cValue& - IntProp(ControlID%, 3)
     IF cValue& < 0 THEN cValue& = 0
     IF cValue& <> VScroll.Value(ControlID) THEN
       VScroll.SetValue ControlID%, cValue&

       SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
  END IF

  
  IF Button.Click(ControlID% + 2) THEN
down1:
     cValue& = VScroll.Value(ControlID%)
     cValue& = cValue& + IntProp(ControlID%, 3)
     IF cValue& > VScroll.MaxValue(ControlID) THEN cValue& = VScroll.MaxValue(ControlID)
     IF cValue& <> VScroll.Value(ControlID) THEN

        VScroll.SetValue ControlID%, cValue&
        SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
  END IF

  'check for large change - up

IF MouseB = 1 AND IntEvent(ControlID% + 3, 29) = 0 THEN

  MX% = MouseX
  MY% = MouseY

  lcupX% = IntProp(ControlID%, 1)
  lcupY% = IntProp(ControlID%, 2) + 21
  lcupX2% = lcupX% + 20
  lcupY2% = IntProp(ControlID% + 3, 2) - 1
  
  IF MX > lcupX% AND MX% < lcupX2% AND MY > lcupY% AND MY < lcupY2% THEN
     GOSUB blinkbase
     cValue& = VScroll.Value&(ControlID%)
     cValue& = cValue& - IntProp(ControlID%, 5)
     IF cValue& < 0 THEN cValue& = 0
     IF cValue& <> VScroll.Value(ControlID) THEN
       VScroll.SetValue ControlID%, cValue&
       SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
     EXIT SUB
  END IF

'check for large change - down

  lcupX% = IntProp(ControlID%, 1)
  lcupY% = IntProp(ControlID% + 3, 2) + IntProp(ControlID% + 3, 4) + 1
  lcupX2% = lcupX% + 20
  lcupY2% = IntProp(ControlID%, 2) + IntProp(ControlID%, 4) - 21

  IF MX > lcupX% AND MX% < lcupX2% AND MY > lcupY% AND MY < lcupY2% THEN
     GOSUB blinkbase
     cValue& = VScroll.Value&(ControlID%)
     cValue& = cValue& + IntProp(ControlID%, 5)
     IF cValue& > VScroll.MaxValue(ControlID) THEN cValue& = VScroll.MaxValue(ControlID)
     IF cValue& <> VScroll.Value(ControlID) THEN
       VScroll.SetValue ControlID%, cValue&
       SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
  END IF

END IF






  IF Button.MouseDown(ControlID% + 3, MB%) THEN
    
    IF MB% = 1 THEN
        MY% = MouseY
        bX% = IntProp(ControlID% + 3, 1)
        bY% = IntProp(ControlID% + 3, 2)
        bX2% = bX% + IntProp(ControlID% + 3, 3)
        bY2% = bY% + IntProp(ControlID% + 3, 4)
        prevMY% = IntProp(ControlID%, 30)
        
        IF prevMY% > 0 THEN
                IF prevMY% < MY THEN
                        tempY% = MY - prevMY%
                        DO WHILE bY2% + tempY% > IntProp(ControlID%, 2) + IntProp(ControlID%, 4) - 21
                          tempY% = tempY% - 1
                        LOOP

                        handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
                        Future.MouseOff
                        Future.EMSGet bX%, bY%, bX2%, bY2%, handle%
                        Future.EMSPut bX%, bY% + tempY%, handle%

                        Future.FILLBOX bX%, IntProp(ControlID%, 2) + 21, bX2%, bY% + tempY% - 1, RGB2Color(180, 180, 180)

                        Future.MouseOn
                        DeallExpMem handle%
                        
                        SetIntProp ControlID% + 3, 2, bY% + tempY%
                        cVal& = CDBL((bY% + tempY%) - IntProp(ControlID%, 2) - 21) * CDBL((VScroll.MaxValue(ControlID%) / CLNG((IntProp(ControlID%, 4) - 72))))
                        IF cVal& <> VScroll.Value(ControlID) THEN
                                SetLongProp ControlID%, 4, cVal&
                                SetIntEvent ControlID%, 1, 1   'Change event index is 1
                        END IF
                END IF

                IF prevMY% > MY THEN

                        tempY% = prevMY% - MY
                        DO WHILE bY% - tempY% < IntProp(ControlID%, 2) + 21
                          tempY% = tempY% - 1
                        LOOP

                        handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
                        Future.MouseOff
                        Future.EMSGet bX%, bY%, bX2%, bY2%, handle%
                        Future.EMSPut bX%, bY% - tempY%, handle%

                        Future.FILLBOX bX%, bY2% - tempY% + 1, bX2%, IntProp(ControlID%, 2) + IntProp(ControlID%, 4) - 21, RGB2Color(180, 180, 180)

                        Future.MouseOn
                        DeallExpMem handle%


                        SetIntProp ControlID% + 3, 2, bY% - tempY%
                        cVal& = CDBL((bY% - tempY%) - IntProp(ControlID%, 2) - 21) * CDBL((VScroll.MaxValue(ControlID%) / CLNG((IntProp(ControlID%, 4) - 72))))
                        IF cVal& <> VScroll.Value(ControlID) THEN
                                SetLongProp ControlID%, 4, cVal&
                                SetIntEvent ControlID%, 1, 1   'Change event index is 1
                        END IF
                END IF
                

                SetIntProp ControlID%, 30, MY
                
                'GOTO doAgain
         ELSE
                SetIntProp ControlID%, 30, MY
        END IF
     END IF
  ELSE
     SetIntProp ControlID%, 30, 0
     IF LongProp(ControlID%, 3) < 1 AND IntProp(ControlID% + 3, 2) > IntProp(ControlID%, 2) + 21 THEN VScroll.SetValue ControlID%, 0
   END IF

EXIT SUB

blinkbase:

Future.MouseOff
Future.FILLBOX lcupX%, lcupY%, lcupX2%, lcupY2%, 0
Future.MouseOn

Delay .06

Future.MouseOff
Future.FILLBOX lcupX%, lcupY%, lcupX2%, lcupY2%, RGB2Color(180, 180, 180)
Future.MouseOn


RETURN
  
'SetIntProp freeID, 1, Left%                             'Left
'SetIntProp freeID, 2, Top%         'Top
'SetIntProp freeID, 3, Width.      'Width
'SetIntProp freeID, 4, Height%     'Height

END SUB

FUNCTION VScroll.Height% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.Height% = IntProp(ControlID, 4)   'Height

END FUNCTION

FUNCTION VScroll.LargeChange% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.LargeChange% = IntProp(ControlID%, 5)  'LargeChange

END FUNCTION

FUNCTION VScroll.Left% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.Left% = IntProp(ControlID, 1)   'left

END FUNCTION

FUNCTION VScroll.MaxValue& (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.MaxValue& = LongProp&(ControlID%, 3)
END FUNCTION

SUB VScroll.ReDraw (ControlID%)

IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB

Left% = IntProp(ControlID, 1)
Top% = IntProp(ControlID, 2)
Height% = IntProp(ControlID, 4)
x2 = Left% + 20
y2 = Top% + Height%

ForeColor& = LongProp(ControlID, 1)'ForeColor
BackColor& = LongProp(ControlID, 2)'BackColor


Future.MouseOff
Future.FILLBOX Left%, Top%, x2%, y2%, RGB2Color(180, 180, 180)

'up button
Button.ReDraw ControlID + 1
Future.MouseOff
Future.PSET Left% + 10, Top% + 7, ForeColor&
Future.LINE Left% + 9, Top% + 8, x2 - 9, Top% + 8, ForeColor&, -1
Future.LINE Left% + 8, Top% + 9, x2 - 8, Top% + 9, ForeColor&, -1
Future.LINE Left% + 7, Top% + 10, x2 - 7, Top% + 10, ForeColor&, -1
Future.LINE Left% + 6, Top% + 11, x2 - 6, Top% + 11, ForeColor&, -1

'down button
Button.ReDraw ControlID + 2
Future.MouseOff
Future.PSET Left% + 10, y2 - 7, ForeColor&
Future.LINE Left% + 9, y2 - 8, x2 - 9, y2 - 8, ForeColor&, -1
Future.LINE Left% + 8, y2 - 9, x2 - 8, y2 - 9, ForeColor&, -1
Future.LINE Left% + 7, y2 - 10, x2 - 7, y2 - 10, ForeColor&, -1
Future.LINE Left% + 6, y2 - 11, x2 - 6, y2 - 11, ForeColor&, -1

'scroll Button
Button.ReDraw ControlID + 3


END SUB

SUB VScroll.ReDrawAll

FOR ctr = 1 TO 150
  IF IntProp(ctr, 28) = 23456 THEN VScroll.ReDraw ctr
NEXT

END SUB

SUB VScroll.SetLargeChange (ControlID%, Value%)

  IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB
  SetIntProp ControlID%, 5, Value%    'LargeChange

END SUB

SUB VScroll.SetMaxValue (ControlID%, Value&)

  IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB

  cValue& = VScroll.Value(ControlID%)
  SetLongProp ControlID%, 3, Value&

  VScroll.SetValue ControlID%, cValue&

END SUB

SUB VScroll.SetSmallChange (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB
  SetIntProp ControlID%, 4, Value%      'SmallChange

END SUB

SUB VScroll.SetTabStop (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB
  SetIntProp ControlID%, 7, Value%    'TabStop index is 7
  SetIntProp ControlID% + 3, 7, Value%  'TabStop index is 7

END SUB

SUB VScroll.SetValue (ControlID%, Value&)

  'IF IntProp(ControlID, 28) <> 23456 THEN EXIT SUB

  CY% = IntProp(ControlID%, 2)
  cHeight% = IntProp(ControlID%, 4)
  cY2% = CY% + cHeight%
  maxValue& = VScroll.MaxValue(ControlID%)

  cValue& = Value&
  IF cValue& > maxValue& THEN cValue& = maxValue&
  IF cValue& < 0 THEN cValue& = 0
  IF VScroll.Value(ControlID%) <> cValue& THEN SetIntEvent ControlID%, 1, 1   'Change event index is 1
  SetLongProp ControlID%, 4, cValue&
  
  bX% = IntProp(ControlID% + 3, 1)
  bY% = IntProp(ControlID% + 3, 2)
  bX2% = bX% + IntProp(ControlID% + 3, 3)
  bY2% = bY% + IntProp(ControlID% + 3, 4)
  
  IF maxValue& > 0 THEN
    ButtY% = cValue& / (maxValue& / CDBL((cHeight% - 72))) + CY% + 21
  ELSE
    ButtY% = CY% + 21
  END IF


  SetIntProp ControlID% + 3, 2, ButtY%

  handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
  Future.MouseOff
  Future.EMSGet bX%, bY%, bX2%, bY2%, handle%

  Future.FILLBOX bX%, CY% + 21, bX2%, cY2% - 21, RGB2Color(180, 180, 180)
  Future.EMSPut bX%, ButtY%, handle%

  Future.MouseOn
  DeallExpMem handle%

END SUB

FUNCTION VScroll.SmallChange% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.SmallChange% = IntProp(ControlID%, 4)  'SmallChange

END FUNCTION

FUNCTION VScroll.TabStop% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.TabStop% = IntProp(ControlID%, 7)     'TabStop index is 7

END FUNCTION

FUNCTION VScroll.Top% (ControlID%)
  IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
  VScroll.Top% = IntProp(ControlID, 2)   'top

END FUNCTION

FUNCTION VScroll.Value& (ControlID%)
        IF IntProp(ControlID, 28) <> 23456 THEN EXIT FUNCTION
        'cY% = IntProp(ControlID%, 2)
        'buttY% = IntProp(ControlID% + 3, 2)
        'cHeight% = IntProp(ControlID%, 4)
        'maxVal& = LongProp(ControlID%, 3)

        'cVal& = CDBL(buttY% - cY% - 21) * round(CDBL((maxVal& / CLNG((cHeight - 72)))), 0)
        VScroll.Value& = LongProp(ControlID%, 4)

END FUNCTION

