'$INCLUDE: 'gcontrol.bi'


CLS
IF IsXMSInstalled <> -1 THEN PRINT "No XMS": END        'check if XMS is installed
IF IsEMMInstalled <> -1 THEN PRINT "No EMS": END        'check if EMS is installed

Set800x600 16
'Set320x200 24
'Set640x480 16
 
temp = InitGCON%(0, mem&)               'Initializes G-Control with no controls saving

IF temp = 1 THEN        'InitGCON returns 1  = insufficient XMS memory
  resetscreen
  PRINT "Insufficient XMS memory."
  END
END IF


future.mouseoff
future.fillbox 0, 0, 800, 600, RGB2Color(200, 200, 200)
list1 = ListBox.Create(250, 50, 250, 300, 0, RGB2Color(255, 255, 255), 3, 64, 10000)  'up to 10000 items can be added to the list

AddItem = Button.Create("Add Item '1'", 250, 370, 250, 30, 0, RGB2Color(200, 200, 200))
RemItem = Button.Create("Remove Item", 250, 410, 250, 30, 0, RGB2Color(200, 200, 200))
InsItem = Button.Create("Insert Item 'ALEX'", 250, 450, 250, 30, 0, RGB2Color(200, 200, 200))

future.mouseoff
future.box 50, 50, 220, 430, 0

future.print 70, 55, "ListBox Events", 0, RGB2Color(200, 200, 200)
future.mouseon

DO
  Updatekey
  UpdateMouse

  Click = ListBox.Click(list1, Item&)
  future.print 60, 70, "Click:" + STR$(Click), 0, RGB2Color(200, 200, 200)
  future.print 60, 90, "  ListIndex:" + STR$(Item&) + "   ", 0, RGB2Color(200, 200, 200)

  Keypress = ListBox.KeyPress(list1, KeyChar$)
  future.print 60, 120, "Keypress:" + STR$(Keypress), 0, RGB2Color(200, 200, 200)
  future.print 60, 150, "  Char: " + KeyChar$, 0, RGB2Color(200, 200, 200)

  Mousedown = ListBox.MouseDown(list1, Button, Item&)
  future.print 60, 170, "MouseDown:" + STR$(Mousedown), 0, RGB2Color(200, 200, 200)
  future.print 60, 190, "  ListIndex:" + STR$(Item&) + "   ", 0, RGB2Color(200, 200, 200)
  future.print 60, 210, "  Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  Mouseup = ListBox.MouseUp(list1, Button)
  future.print 60, 230, "MouseUp:" + STR$(Mouseup), 0, RGB2Color(200, 200, 200)
  future.print 60, 250, "  Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  MouseOver = ListBox.MouseOver(list1, Item&, mx, my)
  future.print 60, 270, "MouseOver:" + STR$(MouseOver), 0, RGB2Color(200, 200, 200)
  future.print 60, 290, "  ListIndex:" + STR$(Item&) + "   ", 0, RGB2Color(200, 200, 200)
  future.print 60, 310, "  X:" + STR$(mx) + "   ", 0, RGB2Color(200, 200, 200)
  future.print 60, 330, "  Y:" + STR$(my) + "   ", 0, RGB2Color(200, 200, 200)
  
  DblClick = ListBox.DblClick(list1, Item&)
  future.print 60, 350, "DblClick:" + STR$(DblClick), 0, RGB2Color(200, 200, 200)
  future.print 60, 370, "  ListIndex:" + STR$(Item&) + "   ", 0, RGB2Color(200, 200, 200)

  IndexChange = ListBox.IndexChange(list1)
  future.print 60, 390, "IndexChange:" + STR$(IndexChange), 0, RGB2Color(200, 200, 200)


  ListBox.DoEvent list1


  IF Button.click(AddItem) THEN
    AddNum& = ListBox.ItemCount(list1) + 1
    ListBox.AddItem list1, LTRIM$(STR$(AddNum&))
    ListBox.Refresh list1
    Button.SetCaption AddItem, "Add Item '" + LTRIM$(STR$(AddNum& + 1)) + "'"
  END IF

  Button.DoEvent AddItem

  IF Button.click(RemItem) THEN
     ListBox.RemoveItem list1, ListBox.ListIndex(list1)
     ListBox.Refresh list1
     AddNum& = ListBox.ItemCount(list1)
     ListBox.Refresh list1
     Button.SetCaption AddItem, "Add Item '" + LTRIM$(STR$(AddNum& + 1)) + "'"
  END IF
  Button.DoEvent RemItem


  IF Button.click(InsItem) THEN
    ListBox.InsertItem list1, ListBox.ListIndex(list1), "ALEX"
    ListBox.Refresh list1
  END IF
  Button.DoEvent InsItem
  
LOOP UNTIL UnivKey = CHR$(27)   'Use UnivKey instead of INKEY$

resetscreen     'reset screen to previous mode
endGCON         'extremely important when you end your program


