'$INCLUDE: 'gcontrol.bi'


CLS
IF IsXMSInstalled <> -1 THEN PRINT "No XMS": END        'check if XMS is installed
IF IsEMMInstalled <> -1 THEN PRINT "No EMS": END        'check if EMS is installed

Set800x600 16
'Set320x200 24
'Set640x480 24

temp = InitGCON%(0, mem&)               'Initializes G-Control with no controls saving
SetBlinkSpeed .2                        'Set cursor blink speed to .2

future.print 10, 10, "XMS Memory needed:" + STR$(mem&), RGB2Color(255, 255, 255), 0
future.print 10, 30, "Free XMS Memory:" + STR$(FreeXMSmemory), RGB2Color(255, 255, 255), 0
future.print 10, 60, "A 70000 line of text will be set to a textbox.", RGB2Color(255, 255, 255), 0
future.print 10, 80, "You may press the X key anytime to end adding of text.", RGB2Color(255, 255, 255), 0

IF temp = 1 THEN        'InitGCON returns 1  = insufficient XMS memory
  resetscreen
  PRINT "Insufficient XMS memory."
  END
ELSE
  SLEEP 3
END IF


future.mouseoff
future.fillbox 0, 0, 800, 600, RGB2Color(200, 200, 200)

text1 = TextBox.Create(220, 10, 300, 300, 0, RGB2Color(255, 255, 255), 64, 70000)

FOR ctr& = 1 TO 70000
  n$ = "Line Number" + STR$(ctr&)
  TextBox.SetLine text1, ctr&, n$ + STRING$(63 - LEN(n$), "X")
  a$ = INKEY$
  IF a$ = "X" OR a$ = "x" THEN EXIT FOR
NEXT

TextBox.Refresh text1

text2 = TextBox.Create(50, 20, 150, 30, 0, RGB2Color(255, 255, 255), 64, 0)
text3 = TextBox.Create(530, 10, 200, 400, 0, RGB2Color(255, 255, 255), 128, 1000)


TextBox.SetLine text3, 1, "ALEX"
TextBox.Refresh text3

future.mouseoff
future.box 50, 100, 200, 430, 0

future.print 70, 105, "TextBox Events", 0, RGB2Color(200, 200, 200)
future.mouseon

DO
  UpdateMouse
  Updatekey

  Click = TextBox.Click(text1)
  future.print 60, 130, "Click:" + STR$(Click), 0, RGB2Color(200, 200, 200)

  Change = TextBox.Change(text1)
  future.print 60, 170, "Change:" + STR$(Change), 0, RGB2Color(200, 200, 200)

  Keypress = TextBox.KeyPress(text1, KeyChar$)
  future.print 60, 210, "Keypress:" + STR$(Keypress), 0, RGB2Color(200, 200, 200)
  future.print 80, 230, "Char: " + KeyChar$, 0, RGB2Color(200, 200, 200)

  Mousedown = TextBox.MouseDown(text1, Button)
  future.print 60, 250, "MouseDown:" + STR$(Mousedown), 0, RGB2Color(200, 200, 200)
  future.print 80, 270, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  Mouseup = TextBox.MouseUp(text1, Button)
  future.print 60, 290, "MouseUp:" + STR$(Mouseup), 0, RGB2Color(200, 200, 200)
  future.print 80, 310, "Button:" + STR$(Button), 0, RGB2Color(200, 200, 200)

  MouseOver = TextBox.MouseOver(text1, mx, my)
  future.print 60, 330, "MouseOver:" + STR$(MouseOver), 0, RGB2Color(200, 200, 200)
  future.print 80, 350, "X:" + STR$(mx) + "   ", 0, RGB2Color(200, 200, 200)
  future.print 80, 370, "Y:" + STR$(my) + "   ", 0, RGB2Color(200, 200, 200)

  GotFocus = TextBox.GotFocus(text1)
  future.print 60, 390, "GotFocus:" + STR$(GotFocus), 0, RGB2Color(200, 200, 200)

  LostFocus = TextBox.LostFocus(text1)
  future.print 60, 410, "LostFocus:" + STR$(LostFocus), 0, RGB2Color(200, 200, 200)


  TextBox.DoEvent text1
  TextBox.DoEvent text2

  TextBox.DoEvent text3

LOOP UNTIL UnivKey = CHR$(27)   'Use UnivKey instead of INKEY$

resetscreen     'reset screen to previous mode
endGCON         'extremely important when you end your program

