DECLARE FUNCTION HScroll.TabStop% (ControlID%)
DECLARE FUNCTION HScroll.Left% (ControlID%)
DECLARE FUNCTION HScroll.Top% (ControlID%)
DECLARE FUNCTION HScroll.Width% (ControlID%)
DECLARE FUNCTION HScroll.Height% (ControlID%)
DECLARE FUNCTION HScroll.LargeChange% (ControlID%)
DECLARE FUNCTION HScroll.SmallChange% (ControlID%)
DECLARE SUB DestroyControl (ControlID%)
DECLARE SUB HScroll.Destroy (ControlID%)
DECLARE SUB HScroll.ReDraw (ControlID%)
DECLARE SUB Button.Redraw (ControlID%)
DECLARE FUNCTION HScroll.Change% (ControlID%)
'Future.Library v3.50
'by Jorden Chamid and Michael Rye Sorensen

'*** SVGA Mouse ***
DECLARE SUB Future.updatemouse ALIAS "SVGAupdatemouse" ()
DECLARE SUB SetMouseRange (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB SetLocation (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMouseMaskColor ALIAS "SVGAmousemask" (BYVAL C&)
DECLARE SUB Future.MouseShape ALIAS "SVGAmouseShape" (BYVAL Offset%, BYVAL Segment%)
DECLARE SUB Future.ResetMouseShape ALIAS "MouseCursorGenerator" ()
DECLARE SUB future.mouseoff ALIAS "SVGAmouseoff" ()
DECLARE SUB future.mouseon ALIAS "SVGAmouseon" ()
DECLARE FUNCTION Future.MouseB% ALIAS "SVGAmouseB" ()
DECLARE FUNCTION Future.MouseY% ALIAS "SVGAmouseY" ()
DECLARE FUNCTION Future.MouseX% ALIAS "SVGAmouseX" ()
DECLARE SUB SetMouseSensitivity (BYVAL H%, BYVAL V%)
'*** Graphics ***
DECLARE SUB Set320x200 (B%)
DECLARE SUB Set320x240 (B%)
DECLARE SUB Set320x400 (B%)
DECLARE SUB Set320x480 (B%)
DECLARE SUB Set400x300 (B%)
DECLARE SUB Set512x384 (B%)
DECLARE SUB Set640x350 (B%)
DECLARE SUB Set640x400 (B%)
DECLARE SUB Set640x480 (B%)
DECLARE SUB Set720x480 (B%)
DECLARE SUB Set720x576 (B%)
DECLARE SUB Set800x600 (B%)
DECLARE SUB Set1024x768 (B%)
DECLARE SUB Set1152x864 (B%)
DECLARE SUB Set1280x960 (B%)
DECLARE SUB Set1280x1024 (B%)
DECLARE SUB Set1600x1200 (B%)
DECLARE SUB Set1920x1080 (B%)
DECLARE SUB Set1920x1200 (B%)
DECLARE SUB Set1920x1440 (B%)
DECLARE SUB Set2048x1536 (B%)
DECLARE SUB SetScreenMode (XRes%, YRes%, Bits%)
DECLARE SUB resetscreen
DECLARE FUNCTION Pages% ()
DECLARE FUNCTION IsVESA%
DECLARE FUNCTION VideoMemory&
DECLARE SUB ViewPage (BYVAL P%)
DECLARE SUB SetFrameBuffer ALIAS "SVGAframesize" (BYVAL X%, BYVAL Y%)
DECLARE SUB SetMaskColor (BYVAL C&)
DECLARE SUB SetPage (BYVAL P%)
DECLARE SUB SetViewPort ALIAS "SVGAviewport" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%)
DECLARE FUNCTION RGB2Color& (BYVAL R%, BYVAL G%, BYVAL B%)
DECLARE SUB Color2RGB (BYVAL C&, R%, G%, B%)
DECLARE FUNCTION Future.Version$ ()
DECLARE FUNCTION SizeOf& ALIAS "SVGAsizeof" (BYVAL X%, BYVAL Y%)
DECLARE FUNCTION Future.ModeList$ (I%)
DECLARE FUNCTION Future.POINT ALIAS "SVGApoint" (BYVAL X%, BYVAL Y%)
DECLARE SUB Future.ScrollUD ALIAS "SVGAscrollud" (BYVAL pixels%)
DECLARE SUB Future.ScrollLR ALIAS "SVGAscrolllr" (BYVAL pixels%)
DECLARE SUB Future.PSET ALIAS "SVGApset" (BYVAL X%, BYVAL Y%, BYVAL C&)
DECLARE SUB Future.CLS ALIAS "SVGAcls" (BYVAL C&)
DECLARE SUB future.fillbox ALIAS "SVGAfillbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.box ALIAS "SVGAbox" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&)
DECLARE SUB future.LINE ALIAS "SVGAline" (BYVAL X%, BYVAL Y%, BYVAL X1%, BYVAL Y1%, BYVAL C&, BYVAL Bitscan%)
DECLARE SUB Future.CIRCLE ALIAS "SVGAcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.FILLCIRCLE ALIAS "SVGAfillcircle" (BYVAL CX%, BYVAL CY%, BYVAL Radius%, BYVAL C&)
DECLARE SUB Future.HLINE ALIAS "SVGAhline" (BYVAL Y%, BYVAL X1%, BYVAL x2%, BYVAL C&)
DECLARE SUB Future.TRIFILL ALIAS "SVGAtrifill" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C&)
DECLARE SUB Future.TRIGOUR ALIAS "SVGAtrigour" (BYVAL X1%, BYVAL Y1%, BYVAL x2%, BYVAL y2%, BYVAL X3%, BYVAL Y3%, BYVAL C1&, BYVAL C2&, BYVAL C3&)
DECLARE SUB Future.TRITEXT (X1%, Y1%, x2%, y2%, X3%, Y3%, U1%, V1%, U2%, V2%, U3%, V3%, Array() AS ANY)
DECLARE SUB Future.ROTATE (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.ROTATEB (X%, Y%, Angle%, Scale!, Array() AS ANY)
DECLARE SUB Future.SNAPSHOT (FileName$)
DECLARE SUB Future.GET (X%, Y%, X1%, Y1%, Array() AS ANY)
DECLARE SUB Future.PUT (X%, Y%, Array() AS ANY)
DECLARE SUB future.print (X%, Y%, t$, C&, B&)
DECLARE SUB Future.LoadGIF (FileName$, Xpos%, Ypos%)
TYPE TGIFInfo
       Filehandle AS INTEGER
       X AS INTEGER
       Y AS INTEGER
       BackgroundColor AS INTEGER
       Pal AS INTEGER
       NColor AS INTEGER
       GlobalCLUT AS STRING * 768
       loopit AS INTEGER
       StartFramePos AS LONG
       FramePos AS LONG
       EOFile AS INTEGER
END TYPE
DECLARE SUB Future.OpenAGif (FileName$, GifHandle AS TGIFInfo)
DECLARE SUB Future.CloseAGif (GifHandle AS TGIFInfo)
DECLARE SUB Future.putAGif (Xpos%, Ypos%, GifHandle AS TGIFInfo)
DECLARE SUB Future.LoadBMP (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadPCX (FileName$, Xpos%, Ypos%)
DECLARE SUB Future.LoadFONT (FileName$)
DECLARE SUB SetFont ALIAS "SVGAsetfont" (BYVAL Mode%)
DECLARE SUB LoadGIF (a$)
DECLARE SUB LoadPCX (a$)
DECLARE SUB LoadBMP (a$)

DECLARE SUB LoadScreen (FileName$)
DECLARE SUB SaveScreen (FileName$)
'*** Key handling ***
DECLARE SUB StickStatus (JoyX%, JoyY%, But1%, But2%, But3%)
DECLARE SUB LockKeys (Nr%, State%)
DECLARE SUB DisableBreak
DECLARE SUB ClearKeyBuffer
DECLARE FUNCTION GetKey% (BYVAL KeyCode%)
DECLARE SUB KBHon ()
DECLARE SUB KBHoff ()
'*** Misc. ***
DECLARE FUNCTION Timer2& ()
DECLARE SUB StartTIMER ()
DECLARE SUB StopTimer ()
DECLARE SUB SetTIMERspeed (BYVAL Frequency%)
DECLARE SUB ResetCounter ()
DECLARE FUNCTION ReadCounter& ()
DECLARE SUB StartSubTIMER (BYVAL TimerNr%)
DECLARE SUB StopSubTIMER (BYVAL TimerNr%)
DECLARE SUB SetSubTIMERspeed (BYVAL Frequency%, BYVAL TimerNr%)
DECLARE SUB ResetSubCounter (BYVAL TimerNr%)
DECLARE FUNCTION ReadSubCounter& (BYVAL TimerNr%)
'*** EMS ***
DECLARE SUB Future.EMSPut (X%, Y%, handle%)
DECLARE SUB Future.EMSGet (X%, Y%, X1%, Y1%, handle%)
DECLARE SUB Future.EMSPutx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMSGetx (Tx%, Ty%, handle%, Sx%, Sy%, Sx1%, Sy1%)
DECLARE SUB Future.EMStoFile (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE SUB Future.FiletoEMS (FileName$, handle%, fileStartpos&, EMSStartpos&, BytesTomove&)
DECLARE FUNCTION GetEMMVersion! ()
DECLARE FUNCTION AllExpMem% (Bytes&)
DECLARE SUB DeallExpMem (handle%)
DECLARE SUB FreeAllExpMem ()
DECLARE FUNCTION PageFrameAddr% ()
DECLARE FUNCTION TotalPages% ()
DECLARE FUNCTION UnallocatedPages% ()
DECLARE FUNCTION IsEMMInstalled% ()
DECLARE SUB SetEMSpage (BYVAL EMSPageNumber%)
DECLARE SUB CopyEMSpage (BYVAL tEMSPageNumber%, BYVAL sEMSPageNumber%)
'*** XMS ***
DECLARE SUB Future.XMSget (X%, Y%, X1%, Y1%, XMShandle%)
DECLARE SUB Future.XMSput (X%, Y%, XMShandle%)
DECLARE FUNCTION IsXMSInstalled% ()
DECLARE FUNCTION AllocateXMS% (BYVAL Bytes&)
DECLARE SUB DeallocateXMS (BYVAL handle%)
DECLARE FUNCTION FreeXMSmemory& ()
DECLARE SUB MoveXMS (BYVAL SourceHandle%, BYVAL SourceOffset&, BYVAL DestHandle%, BYVAL DestOffset&, BYVAL Bytes&)
DECLARE SUB MoveToXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB MoveFromXMS (BYVAL handle%, BYVAL Segment%, BYVAL Offset%, BYVAL Bytes&, BYVAL XMSOffset&)
DECLARE SUB Future.DefineXMSArray (X%, Y%, XMShandle%)
DECLARE SUB Future.XMSArrayGet (X%, Y%, XMShandle%, Index%)
DECLARE SUB Future.XMSArrayPut (X%, Y%, XMShandle%, Index%)

DEFINT A-Z


DECLARE FUNCTION MouseX% ()
DECLARE FUNCTION MouseY% ()
DECLARE FUNCTION MouseB% ()


DECLARE SUB Delay (Counter#)
DECLARE FUNCTION HScroll.Create% (Left%, Top%, Width.%, ForeColor&, BackColor&)
DECLARE SUB HScroll.SetValue (ControlID%, Value&)
DECLARE FUNCTION HScroll.MaxValue& (ControlID%)
DECLARE FUNCTION HScroll.Value& (ControlID%)

DECLARE SUB endvqb ()


DECLARE SUB Button.DoEvent (ControlID%)
DECLARE FUNCTION VScroll.Create% (Left%, Top%, Height%, ForeColor&, BackColor&)

DECLARE FUNCTION XMS2D.GetItem$ (handle AS ANY, xIndex%, yIndex&)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)
DECLARE FUNCTION Button.GotFocus% (ControlID%)
DECLARE FUNCTION Button.Create% (Caption$, Left%, Top%, Width.%, Height%, ForeColor&, BackColor&)
DECLARE FUNCTION Button.KeyPress% (ControlID%, Keychar$)
DECLARE FUNCTION Button.LostFocus% (ControlID%)
DECLARE FUNCTION Button.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION Button.MouseOver% (ControlID%, X%, Y%)
DECLARE FUNCTION Button.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION Button.click% (ControlID%)

DECLARE SUB SetLongProp (ControlID%, Index%, Value&)
DECLARE SUB SetIntProp (ControlID%, Index%, Value%)
DECLARE SUB SetIntEvent (ControlID%, Index%, Value%)
DECLARE FUNCTION UnivSwitch% (ControlID%, Index%)

DECLARE FUNCTION ActiveControl% ()
DECLARE SUB SetActiveControl (ControlID%)
DECLARE FUNCTION IntEvent% (ControlID%, Index%)
DECLARE FUNCTION IntProp% (ControlID%, Index%)
DECLARE FUNCTION LongProp& (ControlID%, Index%)
DECLARE FUNCTION StrProp$ (ControlID%, Index%)
DECLARE SUB SetStrProp (ControlID%, Index%, Value$)

DECLARE FUNCTION UnivKey$ ()

FUNCTION HScroll.Change% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  IF LongProp(ControlID%, 3) > 0 THEN HScroll.Change% = IntEvent(ControlID%, 1) 'Change event index is 1
END FUNCTION

FUNCTION HScroll.Create% (Left%, Top%, Width.%, ForeColor&, BackColor&)

STATIC freeID%

FOR ctr = 1 TO 150
  IF IntProp(ctr, 28) = 0 THEN
    freeID = ctr
    EXIT FOR
  END IF
NEXT

y2 = Top% + 20
x2 = Left% + Width.%

SetStrProp freeID, 1, "hscroll"           'control Type
'SetStrProp freeID, 2, Caption$           'Caption
SetStrProp freeID, 3, ""                 'ToolTipText
SetStrProp freeID, 4, ""                 'Tag

SetIntProp freeID, 1, Left%                             'Left
SetIntProp freeID, 2, Top%         'Top
SetIntProp freeID, 3, Width.      'Width
SetIntProp freeID, 4, 1           'SmallChange
SetIntProp freeID, 5, 1           'LargeChange
SetIntProp freeID, 6, 1                'Enabled
SetIntProp freeID, 7, 1              'TabStop



SetIntProp freeID, 28, 23457           'control type number
'SetIntProp freeID, 29, 0               'No Push switch
SetIntProp freeID, 30, 0               'Force process switch

SetLongProp freeID, 1, ForeColor&  'ForeColor
SetLongProp freeID, 2, BackColor&  'BackColor
maxValue& = Width.% - 70

SetLongProp freeID, 3, maxValue&  'MaxValue

SetLongProp freeID, 4, 0          'Value


HScroll.Create% = freeID

future.mouseoff
future.fillbox Left%, Top%, x2%, y2%, RGB2Color(180, 180, 180)

'up button
temp = Button.Create("", Left%, Top%, 20, 20, ForeColor&, BackColor&)

future.mouseoff
Future.PSET Left% + 7, Top% + 10, ForeColor&
future.LINE Left% + 8, Top% + 9, Left% + 8, y2% - 9, ForeColor&, -1
future.LINE Left% + 9, Top% + 8, Left% + 9, y2% - 8, ForeColor&, -1
future.LINE Left% + 10, Top% + 7, Left% + 10, y2% - 7, ForeColor&, -1
future.LINE Left% + 11, Top% + 6, Left% + 11, y2% - 6, ForeColor&, -1
SetIntProp temp, 7, 0   'set TabStop to 0



'down button

temp = Button.Create("", x2 - 20, Top%, 20, 20, ForeColor&, BackColor&)
future.mouseoff
Future.PSET x2% - 7, Top% + 10, ForeColor&
future.LINE x2% - 8, Top% + 9, x2% - 8, y2% - 9, ForeColor&, -1
future.LINE x2% - 9, Top% + 8, x2% - 9, y2% - 8, ForeColor&, -1
future.LINE x2% - 10, Top% + 7, x2% - 10, y2% - 7, ForeColor&, -1
future.LINE x2 - 11, Top% + 6, x2% - 11, y2% - 6, ForeColor&, -1
SetIntProp temp, 7, 0   'set TabStop to 0

'scroll button
temp = Button.Create("", Left% + 20 + 1, Top%, 30, 20, ForeColor&, BackColor&)
SetIntProp temp, 29, 1               'No Push switch


END FUNCTION

SUB HScroll.Destroy (ControlID%)

  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB

  DestroyControl ControlID

END SUB

SUB HScroll.DestroyAll

FOR ctr = 1 TO 150
  HScroll.Destroy ctr
NEXT

END SUB

SUB HScroll.DoEvent (ControlID%)

  IF IntProp(ControlID%, 28) <> 23457 THEN EXIT SUB

  Future.updatemouse

  STATIC prevMX%, prevMY%, bX%, bY%, bX2%, bY2%, handle%, tempX%, MX%, MY%

  Button.DoEvent ControlID% + 1
  Button.DoEvent ControlID% + 2
  Button.DoEvent ControlID% + 3

  SetIntEvent ControlID%, 1, 0


  IF Button.KeyPress(ControlID% + 3, Keychar$) THEN
    IF Keychar$ = CHR$(0) + CHR$(77) THEN GOTO right1 'right arrow key was pressed at the scroll button
    IF Keychar$ = CHR$(0) + CHR$(75) THEN GOTO left1 'left arrow key was pressed at the scroll button
  END IF


  IF Button.click(ControlID% + 1) THEN
left1:
     cValue& = HScroll.Value&(ControlID%)
     cValue& = cValue& - IntProp(ControlID%, 4)

     IF cValue& < 0 THEN cValue& = 0
     IF cValue& <> HScroll.Value(ControlID) THEN
       HScroll.SetValue ControlID%, cValue&
       SetIntEvent ControlID%, 1, 1   'Change event index is 1
    END IF
  END IF


  IF Button.click(ControlID% + 2) THEN
right1:
     cValue& = HScroll.Value(ControlID%)
     cValue& = cValue& + IntProp(ControlID%, 4)
     IF cValue& > HScroll.MaxValue(ControlID) THEN cValue& = HScroll.MaxValue(ControlID)
     IF cValue& <> HScroll.Value(ControlID) THEN
        HScroll.SetValue ControlID%, cValue&
        SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
  END IF


  'check for large change - left
IF MouseB = 1 AND IntEvent(ControlID% + 3, 29) = 0 THEN

  MX% = MouseX
  MY% = MouseY

  lcupX% = IntProp(ControlID%, 1) + 21
  lcupY% = IntProp(ControlID%, 2)
  lcupX2% = IntProp(ControlID% + 3, 1) - 1
  lcupY2% = lcupY% + 20


  IF MX > lcupX% AND MX% < lcupX2% AND MY > lcupY% AND MY < lcupY2% THEN
     GOSUB blinkbase
     cValue& = HScroll.Value&(ControlID%)
     cValue& = cValue& - IntProp(ControlID%, 5)
     IF cValue& < 0 THEN cValue& = 0
     IF cValue& <> HScroll.Value(ControlID) THEN
        HScroll.SetValue ControlID%, cValue&
        SetIntEvent ControlID%, 1, 1   'Change event index is 1
      END IF
      EXIT SUB
  END IF

'check for large change - right

  lcupX% = IntProp(ControlID% + 3, 1) + IntProp(ControlID% + 3, 3) + 1
  lcupY% = IntProp(ControlID%, 2)
  lcupX2% = IntProp(ControlID%, 1) + IntProp(ControlID%, 3) - 21
  lcupY2% = lcupY% + 20

  IF MX > lcupX% AND MX% < lcupX2% AND MY > lcupY% AND MY < lcupY2% THEN
     GOSUB blinkbase
     cValue& = HScroll.Value&(ControlID%)
     cValue& = cValue& + IntProp(ControlID%, 5)
     IF cValue& > HScroll.MaxValue(ControlID) THEN cValue& = HScroll.MaxValue(ControlID)
     IF cValue& <> HScroll.Value(ControlID) THEN
        HScroll.SetValue ControlID%, cValue&
        SetIntEvent ControlID%, 1, 1   'Change event index is 1
     END IF
  END IF

END IF



  IF Button.MouseDown(ControlID% + 3, MB%) THEN

    IF MB% = 1 THEN
        MX% = MouseX
        prevMX% = IntProp(ControlID%, 30)
        
        bX% = IntProp(ControlID% + 3, 1)
        bY% = IntProp(ControlID% + 3, 2)
        bX2% = bX% + IntProp(ControlID% + 3, 3)
        bY2% = bY% + IntProp(ControlID% + 3, 4)
    
        IF prevMX% > 0 THEN
                IF prevMX% < MX THEN
                        tempX% = MX - prevMX%
                        DO WHILE bX2% + tempX% > IntProp(ControlID%, 1) + IntProp(ControlID%, 3) - 21
                          tempX% = tempX% - 1
                        LOOP

                        handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
                        future.mouseoff
                        Future.EMSGet bX%, bY%, bX2%, bY2%, handle%
                        Future.EMSPut bX% + tempX%, bY%, handle%

                        future.fillbox IntProp(ControlID%, 1) + 21, bY%, bX% + tempX% - 1, bY2%, RGB2Color(180, 180, 180)

                        future.mouseon
                        DeallExpMem handle%

                        SetIntProp ControlID% + 3, 1, bX% + tempX%
                        cVal& = CDBL((bX% + tempX%) - IntProp(ControlID%, 1) - 21) * CDBL((HScroll.MaxValue(ControlID%) / CLNG((IntProp(ControlID%, 3) - 72))))
                        IF cVal& <> HScroll.Value(ControlID) THEN
                                SetLongProp ControlID%, 4, cVal&
                                SetIntEvent ControlID%, 1, 1   'Change event index is 1
                        END IF
                END IF

                IF prevMX% > MX THEN

                        tempX% = prevMX% - MX
                        DO WHILE bX% - tempX% < IntProp(ControlID%, 1) + 21
                          tempX% = tempX% - 1
                        LOOP

                        handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
                        future.mouseoff
                        Future.EMSGet bX%, bY%, bX2%, bY2%, handle%
                        Future.EMSPut bX% - tempX%, bY%, handle%

                        future.fillbox bX2% - tempX + 1, bY%, IntProp(ControlID%, 1) + IntProp(ControlID%, 3) - 21, bY2%, RGB2Color(180, 180, 180)

                        future.mouseon
                        DeallExpMem handle%


                        SetIntProp ControlID% + 3, 1, bX% - tempX%
                        cVal& = CDBL((bX% - tempX%) - IntProp(ControlID%, 1) - 21) * CDBL((HScroll.MaxValue(ControlID%) / CLNG((IntProp(ControlID%, 3) - 72))))

                        IF cVal& <> HScroll.Value(ControlID) THEN

                                SetLongProp ControlID%, 4, cVal&
                                SetIntEvent ControlID%, 1, 1   'Change event index is 1
                        END IF
                END IF


                SetIntProp ControlID%, 30, MX

                'GOTO doAgain
         ELSE
                SetIntProp ControlID%, 30, MX
        END IF
     END IF
   ELSE
     SetIntProp ControlID%, 30, 0
     IF LongProp(ControlID%, 3) < 1 AND IntProp(ControlID% + 3, 1) > IntProp(ControlID%, 1) + 21 THEN HScroll.SetValue ControlID%, 0
   END IF

EXIT SUB

blinkbase:

future.mouseoff
future.fillbox lcupX%, lcupY%, lcupX2%, lcupY2%, 0
future.mouseon

Delay .06

future.mouseoff
future.fillbox lcupX%, lcupY%, lcupX2%, lcupY2%, RGB2Color(180, 180, 180)
future.mouseon


RETURN


'SetIntProp freeID, 1, Left%                             'Left
'SetIntProp freeID, 2, Top%         'Top
'SetIntProp freeID, 3, Width.      'Width
'SetIntProp freeID, 4, Height%     'Height

END SUB

FUNCTION HScroll.LargeChange% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.LargeChange% = IntProp(ControlID%, 5)  'LargeChange
END FUNCTION

FUNCTION HScroll.Left% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.Left% = IntProp(ControlID, 1)                            'Left

END FUNCTION

FUNCTION HScroll.MaxValue& (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.MaxValue& = LongProp&(ControlID%, 3)
END FUNCTION

SUB HScroll.ReDraw (ControlID%)
IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB

'SetStrProp freeID, 1, "hscroll"           'control Type
'SetStrProp freeID, 2, Caption$           'Caption
'SetStrProp freeID, 3, ""                 'ToolTipText
'SetStrProp freeID, 4, ""                 'Tag
'
'SetIntProp freeID, 1, Left%                             'Left
'SetIntProp freeID, 2, Top%         'Top
'SetIntProp freeID, 3, Width.      'Width
'SetIntProp freeID, 4, 1           'SmallChange
'SetIntProp freeID, 5, 1           'LargeChange
'SetIntProp freeID, 6, 1                'Enabled
'SetIntProp freeID, 7, 1                'TabStop

Left% = IntProp(ControlID, 1)
Top% = IntProp(ControlID, 2)
Width.% = IntProp(ControlID, 3)
y2 = Top% + 20
x2 = Left% + Width.%

ForeColor& = LongProp(ControlID, 1)'ForeColor
BackColor& = LongProp(ControlID, 2)'BackColor


future.mouseoff

future.fillbox Left%, Top%, x2%, y2%, RGB2Color(180, 180, 180)

'up button
Button.Redraw ControlID + 1
future.mouseoff
Future.PSET Left% + 7, Top% + 10, ForeColor&
future.LINE Left% + 8, Top% + 9, Left% + 8, y2% - 9, ForeColor&, -1
future.LINE Left% + 9, Top% + 8, Left% + 9, y2% - 8, ForeColor&, -1
future.LINE Left% + 10, Top% + 7, Left% + 10, y2% - 7, ForeColor&, -1
future.LINE Left% + 11, Top% + 6, Left% + 11, y2% - 6, ForeColor&, -1

'down button
Button.Redraw ControlID + 2

future.mouseoff
Future.PSET x2% - 7, Top% + 10, ForeColor&
future.LINE x2% - 8, Top% + 9, x2% - 8, y2% - 9, ForeColor&, -1
future.LINE x2% - 9, Top% + 8, x2% - 9, y2% - 8, ForeColor&, -1
future.LINE x2% - 10, Top% + 7, x2% - 10, y2% - 7, ForeColor&, -1
future.LINE x2 - 11, Top% + 6, x2% - 11, y2% - 6, ForeColor&, -1

'scroll button
Button.Redraw ControlID + 3

END SUB

SUB HScroll.RedrawAll

FOR ctr = 1 TO 150
  IF IntProp(ctr, 28) = 23457 THEN HScroll.ReDraw ctr
NEXT

END SUB

SUB HScroll.SetLargeChange (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB
  SetIntProp ControlID%, 5, Value%    'LargeChange
END SUB

SUB HScroll.SetMaxValue (ControlID%, Value&)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB

  cValue& = HScroll.Value(ControlID%)
  SetLongProp ControlID%, 3, Value&

  HScroll.SetValue ControlID%, cValue&

END SUB

SUB HScroll.SetSmallChange (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB
  SetIntProp ControlID%, 4, Value% 'SmallChange

END SUB

SUB HScroll.SetTabStop (ControlID%, Value%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB
  SetIntProp ControlID%, 7, Value%    'TabStop index is 7
  SetIntProp ControlID% + 3, 7, Value%  'TabStop index is 7


END SUB

SUB HScroll.SetValue (ControlID%, Value&)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT SUB

  CX% = IntProp(ControlID%, 1)
  cWidth% = IntProp(ControlID%, 3)
  cX2% = CX% + cWidth%
  maxValue& = HScroll.MaxValue(ControlID%)

  cValue& = Value&
  IF cValue& > maxValue& THEN cValue& = maxValue&
  IF cValue& < 0 THEN cValue& = 0

  IF HScroll.Value(ControlID%) <> cValue& THEN SetIntEvent ControlID%, 1, 1   'Change event index is 1

  SetLongProp ControlID%, 4, cValue&


  bX% = IntProp(ControlID% + 3, 1)
  bY% = IntProp(ControlID% + 3, 2)
  bX2% = bX% + IntProp(ControlID% + 3, 3)
  bY2% = bY% + IntProp(ControlID% + 3, 4)


  IF maxValue& > 0 THEN
    buttX% = cValue& / (maxValue& / CDBL((cWidth% - 72))) + CX% + 21
  ELSE
    buttX% = CX% + 21
  END IF
  
  SetIntProp ControlID% + 3, 1, buttX%

  handle% = AllExpMem(SizeOf(bX2% - bX% + 1, bY2% - bY% + 1))
  future.mouseoff
  Future.EMSGet bX%, bY%, bX2%, bY2%, handle%

  future.fillbox CX% + 21, bY%, cX2% - 21, bY2%, RGB2Color(180, 180, 180)
  Future.EMSPut buttX%, bY%, handle%

  future.mouseon
  DeallExpMem handle%

END SUB

FUNCTION HScroll.SmallChange% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.SmallChange% = IntProp(ControlID%, 4)  'SmallChange

END FUNCTION

FUNCTION HScroll.TabStop% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.TabStop% = IntProp(ControlID%, 7)     'TabStop index is 7

END FUNCTION

FUNCTION HScroll.Top% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.Top% = IntProp(ControlID, 2)         'Top


END FUNCTION

FUNCTION HScroll.Value& (ControlID%)
        IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
        'cY% = IntProp(ControlID%, 2)
        'buttY% = IntProp(ControlID% + 3, 2)
        'cHeight% = IntProp(ControlID%, 4)
        'maxVal& = LongProp(ControlID%, 3)

        'cVal& = CDBL(buttY% - cY% - 21) * round(CDBL((maxVal& / CLNG((cHeight - 72)))), 0)
        HScroll.Value& = LongProp(ControlID%, 4)

END FUNCTION

FUNCTION HScroll.Width% (ControlID%)
  IF IntProp(ControlID, 28) <> 23457 THEN EXIT FUNCTION
  HScroll.Width% = IntProp(ControlID, 3)    'Width

END FUNCTION

